﻿;==================================================================
; Rosetta Task: ABC Problem
; 
; You are given a collection of ABC blocks. Just like the ones you had when you were a kid. There are twenty 
; blocks with two letters on each block. 
; You are guaranteed to have a complete alphabet amongst all sides of the blocks. 

;The sample blocks are:
; ((B O)
; (X K)
; (D Q)
; (C P)
; (N A)
; (G T)
; (R E)
; (T G)
; (Q D)
; (F S)
; (J W)
; (H U)
; (V I)
; (A N)
; (O B)
; (E R)
; (F S)
; (L Y)
; (P C)
; (Z M))
;
; The goal of this task is to write a function that takes a string and can determine whether you can spell 
; the word with the given collection of blocks. The rules are simple:
; 
; Once a letter on a block is used that block cannot be used again
; The function should be case-insensitive
; Show your output on this page for the following words:
;==================================================================

; Method 1...Iterative
; 
; #LETTERS = "BO XK DQ CP NA GT RE TG QD FS JW HU VI AN OB ER FS LY PC ZM "
;  
; Procedure.s can_make_word(word.s)
;   Define.s letters = #LETTERS, buffer
;   Define.i index1, index2
;   Define.b match
;   For index1=1 To Len(word)
;     index2=1 : match=#False
;     Repeat    
;       buffer=StringField(letters,index2,Space(1))
;       If FindString(buffer,Mid(word,index1,1),1,#PB_String_NoCase)
;         letters=RemoveString(letters,buffer+Chr(32),0,1,1)
;         match=#True
;         Break
;       EndIf
;       index2+1    
;     Until index2>CountString(letters,Space(1))
;     If Not match : ProcedureReturn word+#TAB$+"FALSE" : EndIf
;   Next
;   ProcedureReturn word+#TAB$+"TRUE"
; EndProcedure
;  
; OpenConsole()
; PrintN(can_make_word("a"))
; PrintN(can_make_word("BaRK"))
; PrintN(can_make_word("BOoK"))
; PrintN(can_make_word("TREAt"))
; PrintN(can_make_word("cOMMON"))
; PrintN(can_make_word("SqUAD"))
; PrintN(can_make_word("COnFUSE"))
; Input()
;==================================================================
; Method 2... Recursive

Define.i
#LETTERS = "BO XK DQ CP NA GT RE TG QD FS JW HU VI AN OB ER FS LY PC ZM "
 
Macro test(t)
  Print(t+#TAB$+#TAB$+"= ") : If can_make_word2(t) : PrintN("True") : Else : PrintN("False") : EndIf
EndMacro
 
Procedure.s residue(s$,n.i)
  ProcedureReturn Left(s$,Int(n/3)*3)+Mid(s$,Int(n/3)*3+4)
EndProcedure
 
Procedure.b can_make_word2(word$,letters$=#LETTERS)  
  n=FindString(letters$,Left(word$,1),1,#PB_String_NoCase)
  If Len(word$) And n : ProcedureReturn can_make_word2(Mid(word$,2),residue(letters$,n)) : EndIf
  If Not Len(word$)   : ProcedureReturn #True : Else : ProcedureReturn #False           : EndIf
EndProcedure
 
OpenConsole()
test("a") 
test("BaRK")
test("BOoK")
test("TREAt")
test("cOMMON")
test("SqUAD") 
test("COnFUSE")
Input()
;==================================================================


; IDE Options = PureBasic 5.42 LTS (Windows - x86)
; CursorPosition = 34
; FirstLine = 54
; Folding = -
; EnableUnicode
; EnableXP