﻿;==================================================================
; Rosetta Task: Ackermann function
;
; The Ackermann function is a classic example of a recursive function, notable especially because it is not a 
; primitive recursive function. It grows very quickly in value, as does the size of its call tree.
;
; Its arguments are never negative and it always terminates. Write a function which returns the value of A(m, n). 
; Arbitrary precision is preferred (since the function grows so quickly), but not required.
;==================================================================

Procedure.q Ackermann(m, n)
  If m = 0
    ProcedureReturn n + 1
  ElseIf  n = 0
    ProcedureReturn Ackermann(m - 1, 1)
  Else
    ProcedureReturn Ackermann(m - 1, Ackermann(m, n - 1))
  EndIf
EndProcedure
 
Debug Ackermann(3,4) ; = 125
Debug "---"
Debug Ackermann( 0, 0) ;=            1
Debug Ackermann( 0, 1) ;=            2
Debug Ackermann( 0, 2) ;=            3
Debug Ackermann( 0, 3) ;=            4
Debug Ackermann( 0, 4) ;=            5
Debug Ackermann( 0, 5) ;=            6


; IDE Options = PureBasic 5.42 LTS (Windows - x86)
; CursorPosition = 7
; Folding = -
; EnableUnicode
; EnableXP