﻿;==================================================================
; Rosetta Task: Address of a variable
;
; Basic Data Operation
; This is a basic data operation. It represents a fundamental action on a basic data type.
; 
; You may see other such operations in the basic data operations category, or:
; 
; Demonstrate how to get the address of a variable.
; and how to set the address of a variable.
;==================================================================

; Get the address of a variable using the '@' operator.

a.i = 5
MessageRequester("Address",Str(@a))

; Set the address of a structured pointer. The pointer can be dereferenced to interact with it's data. 
; Ensure that there is access to the memory address that is assigned to the pointer (i.e. part of allocated memory).

a.i = 5
*b.Integer = @a     ; set *b equal to the address of variable a 
*c.Integer = $A100 ; set *c to point at memory location $A100 (in hex)
 
 
MessageRequester("Address",Str(*b)) ;display the address being pointed at by *b
MessageRequester("Value",Str(*b\i)) ;de-reference the pointer *b to display the data being pointed at

; IDE Options = PureBasic 5.42 LTS (Windows - x86)
; CursorPosition = 17
; EnableUnicode
; EnableXP