﻿;==================================================================
; Rosetta Task: Arbitrary-precision integers
; 
; Using the in-built capabilities of your language, calculate the integer value of:
;                         5^{4^{3^2}}
;
; Confirm that the first and last twenty digits of the answer are: 62060698786608744707...92256259918212890625
; Find and show the number of decimal digits in the answer.
;==================================================================

XIncludeFile "Decimal.pbi" ; included in this folder (blueb)

; NOTE: This may take some time!
 
;- Declare the variables that will be used
Define.Decimal *a
Define n, L$, R$, out$, digits.s
 
;- 4^3^2 is withing 32 bit range, so normal procedures can be used
n=Pow(4,Pow(3,2))
 
;- 5^n is larger then 31^2, so the same library call as in the "Long multiplication" task is used
*a=PowerDecimal(IntegerToDecimal(5),IntegerToDecimal(n))
 
;- Convert the large number into a string & present the results
out$=DecimalToString(*a)
L$ = Left(out$,20)
R$ = Right(out$,20)
digits=Str(Len(out$))
out$="First 20 & last 20 chars of 5^4^3^2 are;"+#CRLF$+L$+#CRLF$+R$+#CRLF$
out$+"and the result is "+digits+" digits long."
 
MessageRequester("Arbitrary-precision integers, PureBasic",out$)

; IDE Options = PureBasic 5.42 LTS (Windows - x86)
; CursorPosition = 12
; EnableUnicode
; EnableXP
; DisableDebugger