﻿;==================================================================
; Rosetta Task: Arrays
;
; This task is about arrays. For hashes or associative arrays, please see 'Creating an Associative Array'. 
; 
; In this task, the goal is to show basic Array syntax in your language. 
; Basically, create an array, assign a value to it, and retrieve an element. 
; (If available, show both fixed-length arrays and dynamic arrays, pushing a value into it.)
;==================================================================

; Dim is used to create new arrays and initiate each element will be zero. An array in PureBasic can be of any type, 
; including structured, and user defined types. Once an array is defined it can be resized with ReDim. 
; Arrays are dynamically allocated which means than a variable or an expression can be used to size them.

OpenConsole()
  ;Set up an Array of 23 cells, e.g. 0-22
Dim MyArray.i(22)
  MyArray(0) = 7
  MyArray(1) = 11 
  MyArray(7) = 23
  
; ReDim is used To 'resize' an already declared Array While preserving its content. The new size can be both 
; larger Or smaller, but the number of dimension of the Array can Not be changed after initial creation.

  ;Extend the Array above to 56 items without affecting the already stored data
ReDim MyArray(55)
  MyArray(22) = 7
  MyArray(33) = 11 
  MyArray(44) = 23
  ;Find all 6 non-zero cells from the Array above
For i=0 To ArraySize(MyArray())
  If MyArray(i)
       PrintN(Str(i)+" differs from zero.")
       Input()
  EndIf
Next
  ; Now, set up a multi dimensional Array 
Dim MultiArray.i(800, 600)
  MultiArray(100, 200) = 640
  MultiArray(130,  40) = 120
Dim MultiArray2.i(64, 128, 32)
ans.i = ArraySize(MultiArray2(), 2) ; Will tell that second dimension size is '128'
Debug ans
; IDE Options = PureBasic 5.42 LTS (Windows - x86)
; CursorPosition = 13
; EnableUnicode
; EnableXP