﻿;==================================================================
; Rosetta Task: Assertions
; Assertions are a way of breaking out of code when there is an error or an unexpected input. 
; Some languages throw exceptions and some treat it as a break point.

; Show an assertion in your language by asserting that an integer variable is equal To 42.
;==================================================================

Macro Assert(TEST,MSG="Assert: ")
  CompilerIf #PB_Compiler_Debugger
    If Not (TEST)
      Debug MSG+" Line="+Str(#PB_Compiler_Line)+" in "+#PB_Compiler_File
      CallDebugger
    EndIf
  CompilerEndIf
EndMacro

; Implementation as defined above could be;

A=42
Assert(A=42,"Assert that A=42")
A=42-1
Assert(A=42) ; Where the second test would fail resulting in a message to the 
                   ; programmer With cause (If given by programmer), code line & file.
; IDE Options = PureBasic 5.42 LTS (Windows - x86)
; CursorPosition = 3
; Folding = -
; EnableUnicode
; EnableXP