﻿;==================================================================
; Rosetta Task: Averages - Median

; Write a program to find the median value of a vector of floating-point numbers. The program need not 
; handle the case where the vector is empty, but must handle the case where there are an even number 
; of elements. In that case, return the average of the two middle values.

; There are several approaches to this. One is to sort the elements, and then pick the one(s) in the middle. 
; Sorting would take at least O(n log n). Another would be to build a priority queue from the elements, 
; and then extract half of the elements to get to the middle one(s). This would also take O(n log n).
; The best solution is to use the selection algorithm to find the median in O(n) time.
;==================================================================

Procedure.d median(Array values.d(1), length.i)
  If length = 0 : ProcedureReturn 0.0 : EndIf
  SortArray(values(), #PB_Sort_Ascending)
  If length % 2
    ProcedureReturn values(length / 2)
  EndIf
  ProcedureReturn 0.5 * (values(length / 2 - 1) + values(length / 2))
EndProcedure
 
Procedure.i readArray(Array values.d(1))
  Protected length.i, i.i
  Read.i length
  ReDim values(length - 1)
  For i = 0 To length - 1
    Read.d values(i)
  Next
  ProcedureReturn i
EndProcedure
 
Dim floats.d(0)
Restore array1
length.i = readArray(floats())
Debug median(floats(), length)
Restore array2
length.i = readArray(floats())
Debug median(floats(), length)
 
DataSection
  array1:
    Data.i 7
    Data.d 4.1, 5.6, 7.2, 1.7, 9.3, 4.4, 3.2
  array2:
    Data.i 6
    Data.d 4.1, 7.2, 1.7, 9.3, 4.4, 3.2
EndDataSection


; IDE Options = PureBasic 5.42 LTS (Windows - x86)
; CursorPosition = 10
; Folding = -
; EnableUnicode
; EnableXP