﻿;==================================================================
; Rosetta Task: Bitmap - Flood fill

; Implement a flood fill.
; 
; A flood fill is a way of filling an area using color banks To Define the contained area Or a target color 
; which "determines" the area (the valley that can be flooded; Wikipedia uses the term target color). 
; It works almost like a water flooding from a point towards the banks (or: inside the valley): if there's 
; a hole in the banks, the flood is not contained and all the image (or all the "connected valleys") get filled.
; 
; To accomplish the task, you need to implement just one of the possible algorithms (examples are on Wikipedia). 
; Variations on the theme are allowed (e.g. adding a tolerance parameter or argument for color-matching of the banks or target color).
; 
; Unfilledcirc.png
; Testing: the basic algorithm is not suitable for truecolor images; a possible test image is the one 
; shown on the right box; you can try to fill the white area, or the black inner circle.

;==================================================================

; Note: Can also use the built-in Purebasic procedure (FillArea(x, y, BorderColor [, Color])
;
;                        FillArea(0,0,-1,$ff)
;==================================================================

; Iterative Method... Fills an Area in red
  Procedure Floodfill(x,y,new_color)
    old_color = Point(x,y)
    NewList stack.POINT()
    AddElement(stack()):stack()\x = x : stack()\y = y 
    While(LastElement(stack())) 
      x = stack()\x  : y = stack()\y  
      DeleteElement(stack()) 
      If Point(x,y) = old_color      
         Plot(x, y, new_color)  
         AddElement(stack()):stack()\x = x    : stack()\y = y +1
         AddElement(stack()):stack()\x = x    : stack()\y = y -1
         AddElement(stack()):stack()\x = x +1 : stack()\y = y 
         AddElement(stack()):stack()\x = x -1 : stack()\y = y   
      EndIf  
    Wend    
  EndProcedure
 
  If OpenWindow(0, 0, 0, 200, 200, "Floodfill Beispiel", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
    StartDrawing(WindowOutput(0))
      Box(0, 0, 200, 200, RGB(255, 255, 255))
      DrawingMode(#PB_2DDrawing_Outlined )
      Circle(100, 100, 90, RGB(255 ,0,0)): Circle(120, 80, 30, RGB(255 ,0,0)): Circle(200,200, 70, RGB(255 ,0,0))
 
      Floodfill(40,40,RGB(0 ,255,0))
 
    StopDrawing()
    Repeat
      Event = WaitWindowEvent()
    Until Event = #PB_Event_CloseWindow
  EndIf
; IDE Options = PureBasic 5.42 LTS (Windows - x86)
; CursorPosition = 14
; FirstLine = 7
; Folding = -
; EnableUnicode
; EnableXP