﻿;==================================================================
; Rosetta Task: Boolean values
;
;Show how to represent the boolean states "true" and "false" in a language. If other objects 
; represent "true" or "false" in conditionals, note it.

; PureBasic does not have a Boolean variable type. An integer type is typically used instead. 
; Boolean values are only supported as part of a loop's condition (While/Wend, Repeat/Until) or 
; in a conditional (If/Endif). In these cases if the result of a variable or a numeric expression is 
; zero it is evaluated as false, otherwise it is evaluated as true. A string variable assigned 
; a null string would be evaluated as false.
;==================================================================

; NOTE: As of version 5.10 it does. 

; Syntax
; Bool(<boolean expression>)

; Description

; Bool can be used to evaluate a boolean expression outside of regular conditional operator like If, 
; While, Until etc. If the boolean expression is true, it will return #True, otherwise it will return #False. 

; Example

  Hello$ = "Hello"
  World$ = "World"

  Debug Bool(Hello$ = "Hello")  ; will print 1
  Debug Bool(Hello$ <> "Hello" Or World$ = "World") ; will print 1


; IDE Options = PureBasic 5.42 LTS (Windows - x86)
; CursorPosition = 21
; EnableUnicode
; EnableXP