﻿;==================================================================
; Rosetta Task: CRC-32
; Demonstrate a method of deriving the Cyclic Redundancy Check from within the language. 
;
; The result should be in accordance With ISO 3309, ITU-T V.42, Gzip And PNG. 
; Algorithms are described on Computation of CRC in Wikipedia. This variant of CRC-32 uses LSB-first 
; order, sets the initial CRC to FFFFFFFF16, and complements the final CRC.
; 
; For the purpose of this task, generate a CRC-32 checksum for the ASCII encoded string
;  "The quick brown fox jumps over the lazy dog" (without quotes).

;==================================================================

; Works With: PB Version 5.40
 
a$="The quick brown fox jumps over the lazy dog"
 
UseCRC32Fingerprint() : b$=StringFingerprint(a$, #PB_Cipher_CRC32)
 
OpenConsole()
PrintN("CRC32 Cecksum [hex] = "+UCase(b$))
PrintN("CRC32 Cecksum [dec] = "+Val("$"+b$))
Input()
 
End
; Output:
; CRC32 Cecksum [hex] = 414FA339
; CRC32 Cecksum [dec] = 1095738169
; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 3
; EnableXP
; EnableUnicode