﻿;==================================================================
; Rosetta Task: Call a function in a shared library

; Show how to call a function in a shared library (without dynamically linking to it at compile-time). In particular,
; show how to call the shared library function if the library is available, otherwise use an internal equivalent function.

; This is a special case of calling a foreign language function where the focus is close to the ABI level 
; and not at the normal API level.

;==================================================================

; Older PureBasic versions normally relied on CallFunction() And CallFunctionFast()

     ; If OpenLibrary(0, "USER32.DLL")
     ;   *MessageBox = GetFunction(0, "MessageBoxA")
     ;   CallFunctionFast(*MessageBox, 0, "Body", "Title", 0)
     ;   CloseLibrary(0)
     ; EndIf

; Since versions 4 the recommended way is via the usage of Prototypes even If the old system still is supported.

Prototype.l ProtoMessageBoxW(Window.l, Body.p-unicode, Title.p-unicode, Flags.l = 0)
 
If OpenLibrary(0, "User32.dll")
  MsgBox.ProtoMessageBoxW = GetFunction(0, "MessageBoxW")
  MsgBox(0, "Hello", "World")
  CloseLibrary(0)
EndIf
; IDE Options = PureBasic 5.42 LTS (Windows - x86)
; CursorPosition = 7
; EnableUnicode
; EnableXP