﻿;==================================================================
; Rosetta Task: Catalan numbers

; Catalan numbers are a sequence of numbers which can be defined directly:
; o recursively:
; 
; or alternatively (also recursive):
; 
; Implement at least one of these algorithms and print out the first 15 Catalan numbers with each. 

;==================================================================

; Using the third formula...
; - Saving the division for last ensures we divide the largest numerator by the smallest denominator

Procedure.q CatalanNumber(n.q)
If n<0:ProcedureReturn 0:EndIf
If n=0:ProcedureReturn 1:EndIf
ProcedureReturn (2*(2*n-1))*CatalanNumber(n-1)/(n+1)
EndProcedure
 
ls=25
rs=12
 
a.s=""
a.s+LSet(RSet("n",rs),ls)+"CatalanNumber(n)"
; cw(a.s)
Debug a.s
 
For n=0 To 33 ;33 largest correct quad for n 
a.s=""
a.s+LSet(RSet(Str(n),rs),ls)+Str(CatalanNumber(n))
; cw(a.s)
Debug a.s
Next
;==================================================================


; Sample Output:
;            n             CatalanNumber(n)
;            0             1
;            1             1
;            2             2
;            3             5
;            4             14
;            5             42
;            6             132
;            7             429
;            8             1430
;            9             4862
;           10             16796
;           11             58786
;           12             208012
;           13             742900
;           14             2674440
;           15             9694845
;           16             35357670
;           17             129644790
;           18             477638700
;           19             1767263190
;           20             6564120420
;           21             24466267020
;           22             91482563640
;           23             343059613650
;           24             1289904147324
;           25             4861946401452
;           26             18367353072152
;           27             69533550916004
;           28             263747951750360
;           29             1002242216651368
;           30             3814986502092304
;           31             14544636039226909
;           32             55534064877048198
;           33             212336130412243110; Memoization is Not required, but may be worth the effort when using the second method above.

;==================================================================


; IDE Options = PureBasic 5.42 LTS (Windows - x86)
; CursorPosition = 8
; Folding = -
; EnableUnicode
; EnableXP