﻿;==================================================================
; Rosetta Task: Character codes

; Given a character value in your language, print its code (could be ASCII code, Unicode code, or whatever your language uses).
; 
; For example, the character 'a' (lowercase letter A) has a code of 97 in ASCII (as well As Unicode, as ASCII forms the beginning of Unicode).
; 
; Conversely, given a code, print out the corresponding character.

;==================================================================

;PureBasic allows compiling code so that it will use either Ascii or a Unicode (UCS-2) encoding for 
; representing its string content. It also allows for the source code that is being compiled to be in 
; either Ascii Or UTF-8 encoding. A one-character string is used here to hold the character and a numerical 
; character type is used to hold the character code. The character type is either one or two bytes in size, 
; depending on whether compiling For Ascii Or Unicode respectively.

If OpenConsole()
  ;Results are the same when compiled for Ascii or Unicode
  charCode.c = 97
  Char.s = "a"
  PrintN(Chr(charCode))   ;prints a
  PrintN(Str(Asc(Char)))  ;prints 97
 
  Print(#CRLF$ + #CRLF$ + "Press ENTER to exit")
  Input()
  CloseConsole()
EndIf

;This version should be compiled With Unicode setting And the source code To be encoded using UTF-8.

If OpenConsole()
  ;UTF-8 encoding compiled for Unicode (UCS-2)
  charCode.c = 960 
  Char.s = "π"            
  PrintN(Chr(charCode))   ;prints π
  PrintN(Str(Asc(Char)))  ;prints 960
 
  Print(#CRLF$ + #CRLF$ + "Press ENTER to exit")
  Input()
  CloseConsole()
EndIf
; IDE Options = PureBasic 5.42 LTS (Windows - x86)
; CursorPosition = 14
; EnableUnicode
; EnableXP