﻿;==================================================================
; Rosetta Task: Check that file exists

; In this task, the job is to verify that a file called "input.txt" and the directory called "docs" exist. 
; This should be done twice: once For the current working directory and once for a file and a directory in the filesystem root.
; 
; Optional criteria (May 2015): verify it works With 0-length files; and with an unusual filename: `Abdu'l-Bahá.txt

;==================================================================

result = ReadFile(#PB_Any, "input.txt")
If result>0 : Debug "this local file exists"
  Else : Debug "result=" +Str(result) +" so this local file is missing"
EndIf 
 
result = ReadFile(#PB_Any, "/input.txt")
If result>0 : Debug "this root file exists"
  Else : Debug "result=" +Str(result) +" so this root file is missing"
EndIf 
 
result = ExamineDirectory(#PB_Any,"docs","")
If result>0 : Debug "this local directory exists"
  Else : Debug "result=" +Str(result) +" so this local directory is missing"
EndIf 
 
result = ExamineDirectory(#PB_Any,"/docs","")
If result>0 : Debug "this root directory exists"
  Else : Debug "result=" +Str(result) +" so this root directory is missing"
EndIf 
; IDE Options = PureBasic 5.42 LTS (Windows - x86)
; CursorPosition = 4
; EnableUnicode
; EnableXP