﻿;==================================================================
; Rosetta Task: Closest-pair problem

; This page uses content from Wikipedia. The original article was at closest pair of points problem. The List 
; of authors can be seen in the page history. As with Rosetta Code, the text of Wikipedia is available under 
; the GNU FDL. (See links For details on variance)

; The aim of this task is to provide a function to find the closest two points among a set of given points in 
; two dimensions, i.e. To solve the Closest pair of points problem in the planar case.

;==================================================================

; Brute force version

Procedure.d bruteForceClosestPair(Array P.coordinate(1))
  Protected N=ArraySize(P()), i, j
  Protected mindistance.f=Infinity(), t.d
  Shared a, b
  If N<2
    a=0: b=0
  Else
    For i=0 To N-1
      For j=i+1 To N
        t=Pow(Pow(P(i)\x-P(j)\x,2)+Pow(P(i)\y-P(j)\y,2),0.5)
        If mindistance>t
          mindistance=t
          a=i: b=j
        EndIf
      Next
    Next
  EndIf
  ProcedureReturn mindistance
EndProcedure
 
; Implementation can be As

Structure coordinate
  x.d
  y.d
EndStructure
 
Dim DataSet.coordinate(9)
Define i, x.d, y.d, a, b
 
;- Load data from datasection
Restore DataPoints
For i=0 To 9
  Read.d x: Read.d y
  DataSet(i)\x=x
  DataSet(i)\y=y
Next i
 
If OpenConsole()
  PrintN("Mindistance= "+StrD(bruteForceClosestPair(DataSet()),6))
  PrintN("Point 1= "+StrD(DataSet(a)\x,6)+": "+StrD(DataSet(a)\y,6))
  PrintN("Point 2= "+StrD(DataSet(b)\x,6)+": "+StrD(DataSet(b)\y,6))
  Print(#CRLF$+"Press ENTER to quit"): Input()
EndIf
 
DataSection
  DataPoints:
  Data.d  0.654682, 0.925557, 0.409382, 0.619391, 0.891663, 0.888594
  Data.d  0.716629, 0.996200, 0.477721, 0.946355, 0.925092, 0.818220
  Data.d  0.624291, 0.142924, 0.211332, 0.221507, 0.293786, 0.691701, 0.839186,  0.72826
EndDataSection
; Output:
; Mindistance= 0.077910
; Point 1= 0.891663: 0.888594
; Point 2= 0.925092: 0.818220
; 
; Press ENTER To quit
; IDE Options = PureBasic 5.42 LTS (Windows - x86)
; CursorPosition = 8
; Folding = -
; EnableUnicode
; EnableXP