﻿;==================================================================
; Rosetta Task: Color of a screen pixel

; You are encouraged to solve this task according to the task description, using any language you may know.
; Get color information from an arbitrary pixel on the screen, such as the current location of the mouse cursor. 
; The mouse cursor may or may not have to be active in a GUI created by your program. These functions are OS related.

;==================================================================

;Return the color used at the x,y position in the current output. If the current output has an alpha channel 
; then the result will be a 32bit RGBA value, otherwise it will be a 24bit RGB value. The color can be split 
; into their RGB and alpha values by using the Red(), Green(), Blue() and Alpha() functions.

Color = Point(x, y)
; To get the colour of a pixel on the screen when it is not managed by PureBasic (ie. from other programs' windows),
; it is necessary to use Windows API. This works only under Windows.


hDC = GetDC_(0)
Color = GetPixel_(hDC, x, y)
ReleaseDC_(0, hDC)
;This works fine!!

poz.point
If OpenWindow(0,0,0,100,45,"Get pixel color at cursor position",#PB_Window_MinimizeGadget)
     TextGadget(0,0,0,50,12,"Red: ")
     TextGadget(1,0,15,50,12,"Green: ")
     TextGadget(2,0,30,50,12,"Blue: ")
     TextGadget(3,50,0,50,12,"")
     TextGadget(4,50,15,50,12,"")
     TextGadget(5,50,30,50,12,"")
     hDC = GetDC_(0)
     
     Repeat
          oldx=poz\x
          oldy=poz\y
          GetCursorPos_(@poz)
          Color = GetPixel_(hDC, poz\x, poz\y)
          If poz\x<>oldx Or poz\y<>oldy
               SetGadgetText(3,Str(Red(color)))
               SetGadgetText(4,Str(Green(color)))
               SetGadgetText(5,Str(Blue(color)))
          EndIf
          event=WaitWindowEvent(200)
     Until event=#PB_Event_CloseWindow
    
     ReleaseDC_(0, hDC)
EndIf
; IDE Options = PureBasic 5.42 LTS (Windows - x86)
; CursorPosition = 11
; EnableUnicode
; EnableXP