﻿;==================================================================
; Rosetta Task: Combinations

;Given non-negative integers m and n, generate all size m combinations of the integers from 0 to n-1 in 
; sorted order (each combination is sorted and the entire table is sorted).
; 
; For example, 3 comb 5 is
; 
; 0 1 2
; 0 1 3
; 0 1 4
; 0 2 3
; 0 2 4
; 0 3 4
; 1 2 3
; 1 2 4
; 1 3 4
; 2 3 4

; If it is more "natural" in your language to start counting from 1 instead of 0 the combinations 
; can be of the integers from 1 to n.

;==================================================================

Procedure.s Combinations(amount, choose)
  NewList comb.s()
  ; all possible combinations with {amount} Bits
  For a = 0 To 1 << amount
    count = 0
    ; count set bits
    For x = 0 To amount
      If (1 << x)&a
        count + 1
      EndIf
    Next
    ; if set bits are equal to combination length
    ; we generate a String representing our combination and add it to list
    If count = choose
      string$ = ""
      For x = 0 To amount
        If (a >> x)&1
          ; replace x by x+1 to start counting with 1
          String$ + Str(x) + " "
        EndIf
      Next
      AddElement(comb())
      comb() = string$
    EndIf
  Next
  ; now we sort our list and format it for output as string
  SortList(comb(), #PB_Sort_Ascending)
  ForEach comb()
    out$ + ", [ " + comb() + "]"
  Next
  ProcedureReturn Mid(out$, 3)
EndProcedure
 
Debug Combinations(5, 3)
; IDE Options = PureBasic 5.42 LTS (Windows - x86)
; CursorPosition = 20
; Folding = -
; EnableUnicode
; EnableXP