﻿;==================================================================
; Rosetta Task: Conditional structures
; Control Structures
; These are examples of control structures. You may also be interested in:
; 
; Conditional structures
; Exceptions
; Flow-control structures
; Loops
; This page lists the conditional structures offered by different programming languages.
; Common conditional structures are If-then-else and switch.

;==================================================================

; NOTE: Works With: PureBasic version 4.41

;Using If, ElseIf, Else
If a = 0
  Debug "a = 0"
 
ElseIf a > 0
  Debug "a > 0"
 
Else
  Debug "a < 0"
 
EndIf
;Using Select
Variable = 2
 
Select Variable
  Case 0
    Debug "Variable = 0"
 
  Case 10, 11, 99
    Debug "Variable is 10, 11 or 99"
 
  Case 20 To 30
    Debug "Variable >= 20 And Variable <= 30"
 
  Default
    Debug "Variable = something else..."
EndSelect

;Using CompilerIf...
;Compiler conditional structures works like normal conditional structures, except they are evaluated at 
; compile time, and thus have to use constant expressions. Any defined constant can be used, 
; these examples uses built-in constants.
 
CompilerIf #PB_Compiler_OS = #PB_OS_Linux And #PB_Compiler_Processor = #PB_Processor_x86
  Debug "Compiled on x86 Linux"
CompilerElse
  Debug "Compiled on something else"
CompilerEndIf
 
;Using CompilerSelect...
 
CompilerSelect #PB_Compiler_OS
  CompilerCase #PB_OS_Linux
    Debug "Compiled on Linux"
  CompilerCase #PB_OS_Windows
    Debug "Compiled on Windows"
  CompilerCase #PB_OS_MacOS
    Debug "Compiled on Mac OS"
  CompilerDefault
    Debug "Compiled on something else"
CompilerEndIf
CompilerEndSelect
; IDE Options = PureBasic 5.42 LTS (Windows - x86)
; CursorPosition = 46
; FirstLine = 18
; EnableUnicode
; EnableXP