﻿;==================================================================
; Rosetta Task: Constrained random points on a circle

; Generate 100 <x,y> coordinate pairs such that x and y are integers sampled from the uniform distribution 
; with the condition that. Then display/plot them.
;  The outcome should be a "fuzzy" circle. The actual number of points plotted may be less than 100, 
; given that some pairs may be generated more than once.
; 
; There are several possible approaches to accomplish this. Here are two possible algorithms.
; 
; 1) Generate random pairs of integers and filter out those that don't satisfy this condition:
; 
; {10\leq {\sqrt {x^{2}+y^{2}}}\leq 15} .
;
; 2) Precalculate the set of all possible points (there are 404 of them) and select randomly from this set.

;==================================================================

CreateImage(0,31,31)
StartDrawing(ImageOutput(0))
  For i=1 To 100
    Repeat
      x=Random(30)-15
      y=Random(30)-15
      R.f=Sqr(x*x+y*y)
    Until 10<=R And R<=15
    Plot(x+15,y+15,#Red)
  Next
StopDrawing()
 
Title$="PureBasic Plot"
Flags=#PB_Window_SystemMenu
OpenWindow(0,#PB_Ignore,#PB_Ignore,ImageWidth(0),ImageHeight(0),Title$,Flags)
ImageGadget(0,0,0,ImageWidth(0),ImageHeight(0),ImageID(0))
Repeat: Until WaitWindowEvent()=#PB_Event_CloseWindow
; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 12
; EnableXP
; EnableUnicode