﻿;==================================================================
; Rosetta Task: Convert decimal number to rational

; The task is to write a program to transform a decimal number into a fraction in lowest terms.
; 
; It is not always possible to do this exactly. For instance, while rational numbers can be converted 
; to decimal representation, some of them need an infinite number of digits to be represented exactly 
; in decimal form. Namely, repeating decimals such As 1/3 = 0.333...
; 
; Because of this, the following fractions cannot be obtained (reliably) unless the language 
; has some way of representing repeating decimals:
; 
; 67 / 74 = 0.9(054) = 0.9054054...
; 14 / 27 = 0.(518) = 0.518518...
; Acceptable output:
; 
; 0.9054054 → 4527027 / 5000000
; 0.518518 → 259259 / 500000
; Finite decimals are of course no problem:
; 
; -   0.75 → 3 / 4

;==================================================================

Procedure.i ggT(a.i, b.i)
  Define t.i : If a < b : Swap a, b : EndIf    
  While a%b : t=a : a=b : b=t%a : Wend : ProcedureReturn b    
EndProcedure
 
Procedure.s Dec2Rat(dn.d)
  Define nk$, gt.i, res$
  nk$=Trim(StringField(StrD(dn),2,"."),"0")  
  gt=ggT(Val(nk$),Int(Pow(10.0,Len(nk$))))  
  res$=Str(Val(nk$)/gt)+"/"+Str(Int(Pow(10.0,Len(nk$)))/gt)
  ProcedureReturn res$
EndProcedure
 
OpenConsole()
Define d.d
Repeat
  Read.d d : If Not (d>0.0 And d<1.0) : Break : EndIf
  Print(LSet(StrD(d),15," ")+" -> "+#TAB$+Dec2Rat(d)+#CRLF$)
ForEver
Input() : End
 
DataSection
  Data.d 0.9054054,0.518518,0.75,0.0
EndDataSection

;Results...
; 0.9054054       ->      4527027/5000000
; 0.518518        ->      259259/500000
; 0.75            ->      3/4
; IDE Options = PureBasic 5.42 LTS (Windows - x86)
; CursorPosition = 6
; Folding = -
; EnableUnicode
; EnableXP