﻿;==================================================================
; Rosetta Task: Count in octal

; The task is to produce a sequential count in octal, starting at zero, and using an increment of a one 
; for each consecutive number. Each number should appear on a single line, and the program should count 
; until terminated, or until the maximum value of the numeric type in use is reached.
; 
; Integer sequence is a similar task without the use of octal numbers.

;==================================================================

Procedure.s octal(n.q)
  Static Dim digits(20)
  Protected i, j, result.s
  For i = 0 To 20
    digits(i) = n % 8
    n / 8
    If n < 1
      For j = i To 0 Step -1
        result + Str(digits(j))
      Next 
      Break
    EndIf
  Next 
 
  ProcedureReturn result  
EndProcedure
 
Define n.q
If OpenConsole()
  While n >= 0
    PrintN(octal(n))
    n + 1
  Wend 
 
  Print(#CRLF$ + #CRLF$ + "Press ENTER to exit"): Input()
  CloseConsole()
EndIf
;  
; Sample output:
; 
; 0
; 1
; 2
; 3
; 4
; 5
; 6
; 7
; 10
; 11
; 12
; ...
; 777777777777777777767
; 777777777777777777770
; 777777777777777777771
; 777777777777777777772
; 777777777777777777773
; 777777777777777777774
; 777777777777777777775
; 777777777777777777776
; 777777777777777777777
; IDE Options = PureBasic 5.42 LTS (Windows - x86)
; CursorPosition = 5
; Folding = -
; Markers = 39
; EnableUnicode
; EnableXP