﻿;==================================================================
; Rosetta Task: Create an HTML table

; Create an HTML table.
; 
; The table body should have at least three rows of three columns.
; Each of these three columns should be labelled "X", "Y", And "Z".

; An extra column should be added at either the extreme left or the extreme right of the table that has 
; no heading, but is filled with sequential row numbers.

; The rows of the "X", "Y", And "Z" columns should be filled with random or sequential integers having 4 digits or less.
; The numbers should be aligned in the same fashion for all columns.

;==================================================================


Title.s="Create an HTML table"
 
head.s=""
head.s+"<html><head><title>"+Title.s+"</title></head><body>"+Chr(13)+Chr(10)
 
tablehead.s
tablehead.s+"<table border=1 cellpadding=10 cellspacing=0>"+Chr(13)+Chr(10)
tablehead.s+"<tr><th></th><th>X</th><th>Y</th><th>Z</th></tr>"+Chr(13)+Chr(10)
 
index=0
 
tablebody.s=""
For row=1 To 4
index+1
tablebody.s+"<tr><th>"+Str(index)+"</th>"
For col=1 To 3
tablebody.s+"<td align="+Chr(34)+"right"+Chr(34)+">"+Str(Random(9999,1))+"</td>"
Next 
tablebody.s+"</tr>"+Chr(13)+Chr(10)
Next 
 
tablefoot.s=""
tablefoot.s+"</table>"+Chr(13)+Chr(10)
 
foot.s=""
foot.s+"</body></html>"+Chr(13)+Chr(10)
 
FileName.s="Create_an_HTML_table.html"
If CreateFile(0,FileName.s)
    WriteString(0,head.s)
    WriteString(0,tablehead.s)
    WriteString(0,tablebody.s)
    WriteString(0,tablefoot.s)
    WriteString(0,foot.s)
    CloseFile(0)
    Else
    Debug "Not WriteString :"+FileName.s
EndIf
 
; RunProgram(FileName.s)

; 
; Sample output
; 
; X	Y	Z
; 1	6638	5838	5360
; 2	2995	3856	3093
; 3	37	7644	812
; 4	4428	1100	3721
; 
; The raw HTML
; 
;  
; <html><head><title>Create an HTML table</title></head><body>
; <table border=1 cellpadding=10 cellspacing=0>
; <tr><th></th><th>X</th><th>Y</th><th>Z</th></tr>
; <tr><th>1</th><td align="right">6638</td><td align="right">5838</td><td align="right">5360</td></tr>
; <tr><th>2</th><td align="right">2995</td><td align="right">3856</td><td align="right">3093</td></tr>
; <tr><th>3</th><td align="right">37</td><td align="right">7644</td><td align="right">812</td></tr>
; <tr><th>4</th><td align="right">4428</td><td align="right">1100</td><td align="right">3721</td></tr>
; </table>
; </body></html>
; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 9
; EnableXP
; EnableUnicode