﻿;==================================================================
; Rosetta Task: Create an object at a given address

; Basic Data Operation
; This is a basic Data operation. It represents a fundamental action on a basic Data type.
; 
; You may see other such operations in the Basic Data Operations category, Or:
; 
; Integer Operations 
; Arithmetic | Comparison
; 
; Boolean Operations 
; Bitwise | Logical
; 
; String Operations 
; Concatenation | Interpolation | Comparison | Matching
; 
; Memory Operations 
; Pointers & references | Addresses
; 
; In systems programing it is sometimes required to place language objects at specific memory locations, 
; like I/O registers, hardware interrupt vectors etc.
; 
; Task: Show how language objects can be allocated at a specific machine addresses.
; 
; Since most OSes prohibit access to the physical memory if it is not mapped by the application, 
; As an example, rather than a physical address, take the address of some existing object (using suitable 
; address operations if necessary). For example, create an integer object. Print the machine address of the 
; object. Take the address of the object and create another integer object at this address. Print the value 
; of this object to verify that it is same as one of the origin. Change the value of the origin and verify it again.

;==================================================================

; Allocate a 1Mb memory area work within to avoid conflicts,
; this address could be any number but it may then fail on some systems.
*a=AllocateMemory(1024*1024)
 
; Write a int wit value "31415" at address +312,
; using pointer '*a' with a displacement.
PokeI(*a+312, 31415)
 
; Write a float with value Pi at address +316,
; by creating a new pointer '*b' for this address
*b=*a+316
PokeF(*b, #PI)
 
;Now test it
For i=0 To 1024000 Step 4
  n=PeekI(*a+i)
  If n
    Debug "Int at +"+Str(i)+"  = "+Str(n)
    Debug "Float at +"+Str(i)+"= "+StrF(PeekF(*a+i))
  EndIf
Next
 
; IDE Options = PureBasic 5.42 LTS (Windows - x86)
; CursorPosition = 29
; FirstLine = 7
; EnableUnicode
; EnableXP