﻿;==================================================================
; Rosetta Task: Dot product
; 
; Create a function/use an in-built function, to compute the dot product, also known as the scalar product 
; of two vectors. If possible, make the vectors of arbitrary length.
; 
; As an example, compute the dot product of the vectors [1, 3, -5] and [4, -2, -1].
; 
; If implementing the dot product of two vectors directly, each vector must be the same length; multiply 
; corresponding terms from each vector then sum the results to produce the answer.

;==================================================================

Procedure dotProduct(Array a(1),Array b(1))
  Protected i, sum, length = ArraySize(a())
 
  If ArraySize(a()) = ArraySize(b())
    For i = 0 To length
      sum + a(i) * b(i)
    Next
  EndIf
 
  ProcedureReturn sum
EndProcedure
 
If OpenConsole()
  Dim a(2)
  Dim b(2)
 
  a(0) = 1 : a(1) = 3 : a(2) = -5
  b(0) = 4 : b(1) = -2 : b(2) = -1
 
  PrintN(Str(dotProduct(a(),b())))
 
  Print(#CRLF$ + #CRLF$ + "Press ENTER to exit"): Input()
  CloseConsole()
EndIf
; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 6
; Folding = -
; EnableXP
; EnableUnicode