﻿;==================================================================
; Rosetta Task: Doubly-linked list - Element insertion
; 
; Use the link structure defined in Doubly-Linked List (element) to define a procedure for inserting a link 
; into a doubly-linked List. Call this procedure to insert element C into a list {A,B}, between elements A and B.
; This is much like inserting into a singly-linked list, but with added assignments so that the 
; backwards-pointing links remain correct.

;==================================================================

Structure node
  *prev.node
  *next.node
  value.c ;use character type for elements in this example
EndStructure
 
Procedure insertAfter(element.c, *c.node)
  ;insert new node *n after node *c and set it's value to element
  Protected *n.node = AllocateMemory(SizeOf(node))
  If *n
    *n\value = element
    *n\prev = *c 
    If *c
      *n\next = *c\next
      *c\next = *n
    EndIf
  EndIf 
  ProcedureReturn *n
EndProcedure
 
Procedure displayList(*dl.node)
  Protected *n.node = *dl
  Repeat
    Print(Chr(*n\Value) + " ")
    *n = *n\next
  Until *n = #Null
EndProcedure
 
If OpenConsole()
  Define dl.node, *n.node
 
  *n = insertAfter('A',dl)
  insertAfter('B',*n)
  insertAfter('C',*n)
 
  displayList(dl)
 
  Print(#CRLF$ + #CRLF$ + "Press ENTER to exit")
  Input()
  CloseConsole()
EndIf
; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 5
; Folding = -
; EnableXP
; EnableUnicode