﻿;==================================================================
; Rosetta Task: Empty directory
; 
; Starting with a path to some directory, determine whether the directory is empty.
; 
; An empty directory contains no files nor subdirectories. With Unix or Windows systems, every directory 
; contains an entry for “.” and almost every directory contains “..” (except for a root directory); an empty 
; directory contains no other entries.

;==================================================================

Procedure isDirEmpty(path$)
  If Right(path$, 1) <> "\": path$ + "\": EndIf
  Protected dirID = ExamineDirectory(#PB_Any, path$, "*.*")
  Protected result
 
  If dirID
    result = 1
    While NextDirectoryEntry(dirID)
      If DirectoryEntryType(dirID) = #PB_DirectoryEntry_File Or (DirectoryEntryName(dirID) <> "." And DirectoryEntryName(dirID) <> "..")
        result = 0
        Break
      EndIf 
    Wend 
    FinishDirectory(dirID)
  EndIf 
  ProcedureReturn result
EndProcedure
 
Define path$, result$
 
path$ = PathRequester("Choose a path", "C:\")
If path$
  If isDirEmpty(path$)
    result$ = " is empty."
  Else
    result$ = " is not empty."
  EndIf 
  MessageRequester("Empty directory test", #DQUOTE$ + path$ + #DQUOTE$ + result$)
EndIf 

; Output:
; when selecting directories "L:\vv\6\" And "L:\vv\" :
; "L:\vv\6\" is empty.
; 
; "L:\vv\" is Not empty.
; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 6
; Folding = -
; EnableXP
; EnableUnicode