﻿;==================================================================
; Rosetta Task: Equilibrium index

; An equilibrium index of a sequence is an index into the sequence such that the sum of elements at lower 
; indices is equal to the sum of elements at higher indices. For example, in a sequence {A} :

; {  A_{0}=-7}
; {  A_{1}=1}
; {  A_{2}=5}
; {  A_{3}=2}
; {  A_{4}=-4}
; {  A_{5}=3}
; {  A_{6}=0}

; 3 is an equilibrium index, because:
; 
; {  A_{0}+A_{1}+A_{2}=A_{4}+A_{5}+A_{6}}
; 6 is also an equilibrium index, because:
; 
; {  A_{0}+A_{1}+A_{2}+A_{3}+A_{4}+A_{5}=0}
; (sum of zero elements is zero)
; 
; 7 is not an equilibrium index, because it is not a valid index of sequence {A} .
; 
; Write a function that, given a sequence, returns its equilibrium indices (if any). 
; Assume that the sequence may be very long.

;==================================================================

If OpenConsole()
  Define i, c=CountProgramParameters()-1
  For i=0 To c
    Define j, LSum=0, RSum=0
    For j=0 To c
      If j<i
        LSum+Val(ProgramParameter(j))
      ElseIf j>i
        RSum+Val(ProgramParameter(j))
      EndIf
    Next j
    If LSum=RSum: PrintN(Str(i)): EndIf
  Next i
  Input()
EndIf


; Output:
; > Equilibrium.exe -7 1 5 2 -4 3 0
; 3
; 6
; IDE Options = PureBasic 5.41 LTS (Windows - x64)
; CursorPosition = 42
; EnableUnicode
; EnableXP