﻿;==================================================================
; Rosetta Task: Euler method

; Euler's method numerically approximates solutions of first-order ordinary differential equations (ODEs) 
; with a given initial value. It is an explicit method for solving initial value problems (IVPs)

;==================================================================


Define.d
Prototype.d Func(Time, t)
 
Procedure.d Euler(*F.Func, y0, a, b, h)
  Protected y=y0, t=a
  While t<=b
    PrintN(RSet(StrF(t,3),7)+" "+RSet(StrF(y,3),7))
    y + h * *F(t,y)
    t + h
  Wend
EndProcedure
 
Procedure.d newtonCoolingLaw(Time, t)
  ProcedureReturn -0.07*(t-20)
EndProcedure
 
 
If OpenConsole()
  Euler(@newtonCoolingLaw(), 100, 0, 100, 2)
  Euler(@newtonCoolingLaw(), 100, 0, 100, 5)
  Euler(@newtonCoolingLaw(), 100, 0, 100,10)
 
  Print(#CRLF$ + #CRLF$ + "Press ENTER to exit"): Input()
  CloseConsole()
EndIf
; Output
; ...
;  85.000  20.053
;  90.000  20.034
;  95.000  20.022
; 100.000  20.014
;   0.000 100.000
;  10.000  44.000
;  20.000  27.200
;  30.000  22.160
;  40.000  20.648
;  50.000  20.194
;  60.000  20.058
;  70.000  20.017
;  80.000  20.005
;  90.000  20.002
; 100.000  20.000
; ;==================================================================


; IDE Options = PureBasic 5.41 LTS (Windows - x86)
; CursorPosition = 1
; Folding = -
; EnableUnicode
; EnableXP