﻿;==================================================================
; Rosetta Task: Extreme floating point values
; 
; The IEEE floating point specification defines certain 'extreme' floating point values such as minus 
; zero, -0.0, a value distinct from plus zero; not a number, NaN; and plus and minus infinity.
; 
; The task is to use expressions involving other 'normal' floating point values in your language to 
; calculate these, (and maybe other), extreme floating point values in your language and assign them 
; to variables. Print the values of these variables if possible; and show some arithmetic with these 
; values and variables. 
; If your language can directly enter these extreme floating point values then show it.

;==================================================================

Define.f
If OpenConsole()
  inf =  Infinity() ; or 1/None ;None represents a variable of value = 0
  minus_inf  =  -Infinity() ; or -1/None
  minus_zero = -1/inf 
  nan = NaN() ; or None/None
 
  PrintN("positive infinity: "+StrF(inf))
  PrintN("negative infinity: "+StrF(minus_inf))
  PrintN("positive zero: "+StrF(None))
  PrintN("negative zero: "+StrF(minus_zero)) ; handles as 0.0
  PrintN("not a number: "+StrF(nan))
  PrintN("Arithmetics")  
  PrintN("+inf + 2.0 =  "+StrF(inf + 2.0))
  PrintN("+inf - 10.1 = "+StrF(inf - 10.1))
  PrintN("+inf + -inf = "+StrF(inf + minus_inf))
  PrintN("0.0 * +inf =  "+StrF(0.0 * inf))
  PrintN("1.0/-0.0 =  "+StrF(1.0/minus_zero))
  PrintN("NaN + 1.0 = "+StrF(nan + 1.0))
  PrintN("NaN + NaN = "+StrF(nan + nan))
  PrintN("Logics")
  If IsInfinity(inf): PrintN("Variable 'Infinity' is infinite"): EndIf
  If IsNAN(nan): PrintN("Variable 'nan' is not a number"): EndIf
 
  Print(#CRLF$+"Press ENTER to EXIT"): Input()
EndIf

; Output
; positive infinity: +Infinity
; negative infinity: -Infinity
; positive zero: 0
; negative zero: 0
; Not a number: NaN
; Arithmetics
; +inf + 2.0 =  +Infinity
; +inf - 10.1 = +Infinity
; +inf + -inf = NaN
; 0.0 * +inf =  NaN
; 1.0/-0.0 =  -Infinity
; NaN + 1.0 = NaN
; NaN + NaN = NaN
; Logics
; Variabel 'Infinity' is infinite
; Variable 'nan' is Not a number
; 
; Press ENTER To EXIT
; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 10
; FirstLine = 4
; EnableXP
; EnableUnicode