﻿;==================================================================
; Rosetta Task: Factors of an integer
; 
; Compute the factors of a positive integer. These factors are the positive integers by which the 
; number being factored can be divided to yield a positive integer result. (Though the concepts function 
; correctly for zero and negative integers, the set of factors of zero has countably infinite members, and 
; the factors of negative integers can be obtained from the factors of related positive numbers without 
; difficulty; this task does not require handling of either of these cases). Note that every prime number 
; has two factors; ‘1’ and itself.

;==================================================================

Procedure PrintFactors(n)
  Protected i, lim=Round(Sqr(n),#PB_Round_Up)
  NewList F.i()
  For i=1 To lim
    If n%i=0
      AddElement(F()): F()=i
      AddElement(F()): F()=n/i
    EndIf
  Next
  ;- Present the result
  SortList(F(),#PB_Sort_Ascending)
  ForEach F()
    Print(Str(F())+" ")
  Next
EndProcedure
 
If OpenConsole()
  Print("Enter integer to factorize: ")
  PrintFactors(Val(Input()))
  Print(#CRLF$+#CRLF$+"Press ENTER to quit."): Input()
EndIf

; Output:
;  Enter integer to factorize: 96
;  1 2 3 4 6 8 12 16 24 32 48 96
; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 35
; Folding = -
; EnableXP
; EnableUnicode