﻿;==================================================================
; Rosetta Task: Fibonacci n-step number sequences

; The task is to:
; Write a function to generate Fibonacci {n} -Step number sequences given its initial values 
; and assuming the number of initial values determines how many previous values are summed to make 
; the next number of the series.
;
; Use this to print and show here at least the first ten members of the Fibo/tribo/tetra-nacci and Lucas sequences.

;==================================================================

Procedure.i FibonacciLike(k,n=2,p.s="",d.s=".")
Protected i,r
If k<0:ProcedureReturn 0:EndIf
If p.s
n=CountString(p.s,d.s)+1
For i=0 To n-1
If k=i:ProcedureReturn Val(StringField(p.s,i+1,d.s)):EndIf
Next
Else
If k=0:ProcedureReturn 1:EndIf
If k=1:ProcedureReturn 1:EndIf
EndIf
For i=1 To n
r+FibonacciLike(k-i,n,p.s,d.s)
Next
ProcedureReturn r
EndProcedure
 
; The fact that PureBasic supports default values for procedure parameters 
; is very useful in a case such as this. 
; Since:
; k=4
; Debug FibonacciLike(k)               ;good old Fibonacci
 
; Debug FibonacciLike(k,3)             ;here we specified n=3 [Tribonacci]
; Debug FibonacciLike(k,3,"1.1.2")     ;using the default delimiter "."
; Debug FibonacciLike(k,3,"1,1,2",",") ;using a different delimiter ","
; the last three all produce the same result.
 
; as do the following two for the Lucas series:
; Debug FibonacciLike(k,2,"2.1")     ;using the default delimiter "."
; Debug FibonacciLike(k,2,"2,1",",") ;using a different delimiter ","
 
m=10
t.s=LSet("n",5)
For k=0 To m
  t.s+LSet(Str(k),5)
  Next
Debug t.s
For n=2 To 10
  t.s=LSet(Str(n),5)
  For k=0 To m
    t.s+LSet(Str(FibonacciLike(k,n)),5)
    Next
Debug t.s
Next
Debug ""
p.s="2.1"
t.s=LSet(p.s,5)
For k=0 To m
  t.s+LSet(Str(FibonacciLike(k,n,p.s)),5)
  Next
Debug t.s
Debug ""
 
 
; Sample Output
; 
; n    0    1    2    3    4    5    6    7    8    9    10   
; 2    1    1    2    3    5    8    13   21   34   55   89   
; 3    1    1    2    4    7    13   24   44   81   149  274  
; 4    1    1    2    4    8    15   29   56   108  208  401  
; 5    1    1    2    4    8    16   31   61   120  236  464  
; 6    1    1    2    4    8    16   32   63   125  248  492  
; 7    1    1    2    4    8    16   32   64   127  253  504  
; 8    1    1    2    4    8    16   32   64   128  255  509  
; 9    1    1    2    4    8    16   32   64   128  256  511  
; 10   1    1    2    4    8    16   32   64   128  256  512  
; 
; 2.1  2    1    3    4    7    11   18   29   47   76   123  
; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 8
; Folding = -
; EnableXP
; EnableUnicode