﻿;==================================================================
; Rosetta Task: File input - Output

; File input/output is part of Short Circuit's Console Program Basics selection.

; In this task, the job is to create a file called "output.txt", and place in it the contents of the file "input.txt",
; via an intermediate variable. In other words, your program will demonstrate: (1) how to read from a 
; file into a variable, and (2) how to write a variable's contents into a file. Oneliners that skip the intermediate 
; variable are of secondary interest — operating systems have copy commands for that.

;==================================================================
; Possibilities:

; #1 - Basic file copy

CopyFile("input.txt","output.txt")

; #2 - Line by line

in = ReadFile(#PB_Any,"input.txt")
If in
  out = CreateFile(#PB_Any,"output.txt")
  If out
    Define MyLine$
    While Not Eof(in)
      MyLine$ = ReadString(in) 
      WriteString(out,MyLine$) 
    Wend
    CloseFile(out)
  EndIf
  CloseFile(in)
EndIf

; #3 - Reading & writing the complete file in one pass

If ReadFile(0,"input.txt")
  Define MyLine$, *Buffer, length
  length=FileSize("input.txt")
  *Buffer = AllocateMemory(length)
  If *Buffer   
    If OpenFile(1,"output.txt")
      ReadData(0, *Buffer, length)
      WriteData(1, *Buffer, length)
      CloseFile(1)
    EndIf
    FreeMemory(*Buffer)
  EndIf
  CloseFile(0)
EndIf

; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 7
; EnableXP
; EnableUnicode