﻿;==================================================================
; Rosetta Task: Find common directory path
; 
; Create a routine that, given a set of strings representing directory paths and a single character directory 
; separator, will return a string representing that part of the directory tree that is common to all the directories.
; 
; Test your routine using the forward slash '/' character as the directory separator and the following three strings as input paths:
; e.g.
;  '/home/user1/tmp/coverage/test'
;  '/home/user1/tmp/covert/operator'
;  '/home/user1/tmp/coven/members'

; Note: The resultant path should be the valid directory '/home/user1/tmp' and not the longest common string '/home/user1/tmp/cove'.
; If your language has a routine that performs this function (even if it does not have a changeable separator character), 
; then mention it as part of the task.

;==================================================================

;PureBasic does not have a path comparator directly but instead has powerful string tools.

;Simply by checking the catalog names until they mismatch and add up the correct parts, the task is accomplished.

Procedure.s CommonPath(Array InPaths.s(1), separator.s="/")
  Protected SOut$=""
  Protected i, j, toggle
 
  If ArraySize(InPaths())=0
    ProcedureReturn InPaths(0)  ; Special case, only one path
  EndIf
 
  Repeat
    i+1
    toggle=#False
    For j=1 To ArraySize(InPaths())
      If (StringField(InPaths(j-1),i,separator)=StringField(InPaths(j),i,separator))
        If Not toggle
          SOut$+StringField(InPaths(j-1),i,separator)+separator
          toggle=#True
        EndIf
      Else
        ProcedureReturn SOut$
      EndIf      
    Next
  ForEver
EndProcedure

; Example of implementation
; 
Dim t.s(2)
t(0)="/home/user1/tmp/coverage/test"
t(1)="/home/user1/tmp/covert/operator"
t(2)="/home/user1/tmp/coven/members"
 
Debug CommonPath(t(),"/")
; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 44
; FirstLine = 6
; Folding = -
; EnableXP
; EnableUnicode