﻿;==================================================================
; Rosetta Task: Find limit of recursion

; Find the limit of recursion.

; NOTE: >>>>>>>>>>>Below - Test one or the other <<<<<<<<<<<<<<<<

;==================================================================

; The recursion limit is primarily determined by the stack size. The stack size can be changed when compiling 
; a program by specifying the new size using '/stack:NewSize' in the linker file.

; #1 - Procedural

; In addition to the stack size the recursion limit for procedures is further limited by the procedure's parameters 
; and local variables which are also stored on the same stack.

OpenConsole()
Procedure Recur(n)
  PrintN(Str(n))
  Recur(n+1)
EndProcedure
 
; Debug Recur(1)
; Will get - Stack overflow after 86317 recursions on x86 Vista.

; ===============================================
; #2 - Classic

rec:
  PrintN(Str(n))
  n+1
  Gosub rec
  Return
  
; Will get - Stack overflow after 258931 recursions on x86 Vista.
; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 14
; Folding = -
; EnableXP
; EnableUnicode