﻿;==================================================================
; Rosetta Task: Find the missing permutation

; These are all of the permutations of the symbols A, B, C And D, except for one that's not listed. 
; Find that missing permutation.
; 
; There is an obvious method : enumerating all permutations of A, B, C, D, and looking for the missing one.
; 
; There is an alternate method. Hint : If all permutations were here, how many times would A appear in 
; each position ? What is the parity of this number ?
; 
; There is another alternate method. 
; Hint: If you add up the letter values of each column, does a missing 
; letter A, B, C, D from each column cause the total value for each column to be unique?

;==================================================================

Procedure in_List(in.s)
  Define.i i, j
  Define.s a
  Restore data_to_test
  For i=1 To 3*8-1
    Read.s a
    If in=a
      ProcedureReturn #True
    EndIf
  Next i
  ProcedureReturn #False
EndProcedure
 
Define.c z, x, c, v
If OpenConsole()
  For z='A' To 'D'
    For x='A' To 'D'
      If z=x:Continue:EndIf
      For c='A' To 'D'
        If c=x Or c=z:Continue:EndIf
        For v='A' To 'D'
          If v=c Or v=x Or v=z:Continue:EndIf
          Define.s test=Chr(z)+Chr(x)+Chr(c)+Chr(v)
          If Not in_List(test)
            PrintN(test+" is missing.")
          EndIf 
        Next
      Next
    Next
  Next
  PrintN("Press Enter to exit"):Input()
EndIf
 
DataSection
data_to_test:
  Data.s "ABCD","CABD","ACDB","DACB","BCDA","ACBD","ADCB","CDAB"
  Data.s "DABC","BCAD","CADB","CDBA","CBAD","ABDC","ADBC","BDCA"
  Data.s "DCBA","BACD","BADC","BDAC","CBDA","DBCA","DCAB"
EndDataSection

; ;Based on the Permutations task, the solution could be:
; 
; If OpenConsole()
;   NewList a.s()
;   findPermutations(a(), "ABCD", 4)
;   ForEach a()
;     Select a()
;       Case "ABCD","CABD","ACDB","DACB","BCDA","ACBD","ADCB","CDAB","DABC"
;       Case "BCAD","CADB","CDBA","CBAD","ABDC","ADBC","BDCA","DCBA","BACD"
;       Case "BADC","BDAC","CBDA","DBCA","DCAB"
;       Default
;         PrintN(A()+" is missing.")
;     EndSelect
;   Next
;  
;   Print(#CRLF$ + "Press ENTER to exit"): Input()
; EndIf
; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 13
; Folding = -
; EnableXP
; EnableUnicode