﻿;==================================================================
; Rosetta Task: Flatten a list

; Write a function to flatten the nesting in an arbitrary list of values. Your program should work on 
; the equivalent of thislist:   [[1], 2, [[3, 4], 5], [[[]]], [[[6]]], 7, 8, []]
;
; Where the correct result would be the list:   [1, 2, 3, 4, 5, 6, 7, 8]

;==================================================================

Structure RCList
  Value.i
  List A.RCList()
EndStructure
 
Procedure Flatten(List A.RCList())
  ResetList(A())
  While NextElement(A())
    With A()
      If \Value
        Continue
      Else
        ResetList(\A())
        While NextElement(\A())
          If \A()\Value: A()\Value=\A()\Value: EndIf
        Wend
      EndIf
      While ListSize(\A()): DeleteElement(\A()): Wend
      If Not \Value: DeleteElement(A()): EndIf
    EndWith
  Wend
EndProcedure
; ---------------------------------------------------------------------------
;Set up the MD-List & test the Flattening Procedure.

;- Set up two lists, one multi dimensional and one 1-D.
NewList A.RCList()
 
;- Create a deep list
With A()
  AddElement(A()):  AddElement(\A()): AddElement(\A()): \A()\Value=1
  AddElement(A()):                     A()\Value=2
  AddElement(A()):  AddElement(\A()): \A()\Value=3
  AddElement(\A()):                   \A()\Value=4
  AddElement(A()):  AddElement(\A()): \A()\Value=5
  AddElement(A()):  AddElement(\A()): AddElement(\A()): AddElement(\A())
  AddElement(A()):  AddElement(\A()): AddElement(\A()): \A()\Value=6
  AddElement(A()):                     A()\Value=7
  AddElement(A()):                     A()\Value=8
  AddElement(A()):  AddElement(\A()): AddElement(\A())
EndWith
 
Flatten(A())
 
;- Present the result
If OpenConsole()
  Print("Flatten: [")
  ForEach A()
    Print(Str(A()\Value))
    If ListIndex(A())<(ListSize(A())-1)
      Print(", ")
    Else
      PrintN("]")
    EndIf
  Next
  Print(#CRLF$+"Press ENTER to quit"): Input()
EndIf

; Results.... Flatten: [1, 2, 4, 5, 6, 7, 8]
; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 6
; Folding = -
; EnableXP
; EnableUnicode