﻿;==================================================================
; Rosetta Task: Flow-control structures

; In this task, we document common flow-control structures. One common example of a flow-control 
; structure is the goto construct. 

; Note that conditional structures and loop structures have their own articles/categories.

;==================================================================

; Goto Method
; Transfers control to the label referenced. It is not a safe way to exit loops.

If OpenConsole()
  top:
  i = i + 1
  PrintN("Hello world.")
  If i < 10
    Goto top
  EndIf 
 
  Print(#CRLF$ + #CRLF$ + "Press ENTER to exit")
  Input()
  CloseConsole()
EndIf 
;==================================================================

; Gosub & Return Method
; Gosub stands For 'Go to sub routine'. A label must be specified after Gosub where the program execution 
; continues And will do so Until encountering a Return. When a Return is reached, the program execution 
; is then transferred immediately below the Gosub. Gosub is useful when building fast structured code With very low overhead.

X=1:  Y=2
Gosub Calc
;X will now equal 7
End
 
Calc:
  X+3*Y
  Return ; Returns to the point in the code where the Gosub jumped from
;==================================================================
  
; FakeReturn Method
; If the command Goto is used within the body of a sub routine, FakeReturn must be used To 
; correct the stack Or the program will crash.

Gosub MySub
 
Lable2:
; The program will jump here, then 'end'
End
 
MySub:
If #PI>3
  FakeReturn  ; This will simulate the function of a normal "Return".
  Goto Lable2
EndIf 
Return
;==================================================================
  
; OnErrorGoto Method
; This will transferee the program execution To the defined label If an error accrue.

OnErrorGoto(?MyExitHandler)
 
X=1: Y=0
z= X/Y
; = a illegal division with zero
Debug "This line should never be reached"
End
 
MyExitHandler:
  MessageRequester("Error", ErrorMessage())
  End
;==================================================================
  
; OnErrorCall Method
;Similar To OnErrorGoto() but procedural instead.

Procedure MyErrorHandler()
  ;All open files etc can be closed here
  MessageRequester("Error", ErrorMessage())
  End
EndProcedure
 
OnErrorCall(MyErrorHandler())
X=1: Y=0
Z= X/Y
;This line should never be reached
; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 11
; FirstLine = 41
; Folding = -
; EnableXP
; EnableUnicode