﻿;==================================================================
; Rosetta Task: Floyds triangle

; Floyd's triangle lists the natural numbers in a right triangle aligned to the left where
; 
; the first row is just 1
; successive rows start towards the left with the next number followed by successive naturals listing one 
; more number than the line above.
;
; The first few lines of a Floyd triangle looks like this:
; 
;  1
;  2  3
;  4  5  6
;  7  8  9 10
; 11 12 13 14 15
;
; The task is to:
; 
; Write a program to generate and display here the first n lines of a Floyd triangle.
; (Use n=5 And n=14 rows).
; Ensure that when displayed in a monospace font, the numbers line up in vertical columns as shown 
; and that only one space separates numbers of the last row.

;==================================================================

Procedure.i sumTo(n) 
  Protected r,i
  For i=1 To n 
    r+i
  Next 
  ProcedureReturn r.i
EndProcedure
 
; [1]
; array rsA(n)... string-lengths of the numbers
; in the bottom row
 
; [2]
; sumTo(i-1)+1    to     sumTo(i)
           ; 11 12 13 14 15
  ; here k is the column-index for array rsA(k)
 
Procedure.s FloydsTriangle(n)
  Protected r.s,s.s,t.s,i,j,k
  ; [1]
  Dim rsA(n)
  i=0
  For j=sumTo(n-1)+1 To sumTo(n)
    i+1
    rsA(i)=Len(Str(j))
  Next
  ; [2]
  For i=1 To n 
    t.s="":k=0
    For j=sumTo(i-1)+1 To sumTo(i)
      k+1:t.s+RSet(Str(j),rsA(k)," ")+" "
    Next 
    r.s+RTrim(t.s)+Chr(13)+Chr(10)
  Next 
  r.s=Left(r.s,Len(r.s)-2)
  ProcedureReturn r.s
EndProcedure
 
If OpenConsole() 
  n=5
  r.s=FloydsTriangle(n)
  PrintN(r.s)
 
  n=14
  r.s=FloydsTriangle(n)
  PrintN(r.s)
 
  Print(#CRLF$ + #CRLF$ + "Press ENTER to exit"): Input()
  CloseConsole()
EndIf
; Sample Output
; 
;  1
;  2  3
;  4  5  6
;  7  8  9 10
; 11 12 13 14 15
;  1
;  2  3
;  4  5  6
;  7  8  9 10
; 11 12 13 14 15
; 16 17 18 19 20 21
; 22 23 24 25 26 27 28
; 29 30 31 32 33 34 35 36
; 37 38 39 40 41 42 43 44  45
; 46 47 48 49 50 51 52 53  54  55
; 56 57 58 59 60 61 62 63  64  65  66
; 67 68 69 70 71 72 73 74  75  76  77  78
; 79 80 81 82 83 84 85 86  87  88  89  90  91
; 92 93 94 95 96 97 98 99 100 101 102 103 104 105
; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 22
; Folding = -
; EnableXP
; EnableUnicode