﻿;==================================================================
; Rosetta Task: Forward difference

; Provide code that produces a list of numbers which is the n-th order forward difference, given a 
; non-negative integer (specifying the order) and a list of numbers. 
;==================================================================

Procedure forward_difference(List a())
  If ListSize(a()) <= 1
    ClearList(a()): ProcedureReturn
  EndIf
  Protected NewList b()
  CopyList(a(), b())
  LastElement(a()): DeleteElement(a())
  SelectElement(b(), 1)
  ForEach a()
    a() - b(): NextElement(b())
  Next 
EndProcedure
 
Procedure nth_difference(List a(), List b(), n)
  Protected i
  CopyList(a(), b())
  For i = 1 To n
    forward_difference(b())
  Next 
EndProcedure
 
Procedure.s display(List a())
  Protected output.s
  ForEach a()
    output + Str(a()) + ","
  Next
  ProcedureReturn RTrim(output,",")
EndProcedure
 
DataSection
  ;list data
  Data.i 10 ;element count
  Data.i 90, 47, 58, 29, 22, 32, 55, 5, 55, 73
EndDataSection
 
;create and fill list
Define i
NewList a()
Read.i i
While i > 0
  AddElement(a()): Read.i a(): i - 1
Wend
 
If OpenConsole()
  NewList b()
  For i = 1 To 10
    nth_difference(a(), b(), i)
    PrintN(Str(i) + "   [" + display(b()) + "]")
  Next
 
  Print(#CRLF$ + #CRLF$ + "Press ENTER to exit"): Input()
  CloseConsole()
EndIf 
 
;  
; Output:
; 1   [43,-11,29,7,-10,-23,50,-50,-18]
; 2   [54,-40,22,17,13,-73,100,-32]
; 3   [94,-62,5,4,86,-173,132]
; 4   [156,-67,1,-82,259,-305]
; 5   [223,-68,83,-341,564]
; 6   [291,-151,424,-905]
; 7   [442,-575,1329]
; 8   [1017,-1904]
; 9   [2921]
; 10   []



; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 4
; Folding = -
; EnableXP
; EnableUnicode