﻿;==================================================================
; Rosetta Task: GUI - Maximum window dimensions
;
; The task is to determine the maximum height and width of a window that can fit within the physical 
; display area of the screen without scrolling. This is effectively the screen size (not the total desktop 
; area, which could be bigger than the screen display area) in pixels minus any adjustments for window
; decorations and menubars. 

; The idea is to determine the physical display parameters for the maximum
; height and width of the usable display area in pixels (without scrolling). The values calculated should
; represent the usable desktop area of a window maximized to fit the the screen. 
;==================================================================

If OpenWindow(0, 0, 0, 5, 5, "", #PB_Window_Maximize + #PB_Window_Invisible)
  maxX = WindowWidth(0)
  maxY = WindowHeight(0)
  CloseWindow(0)
  MessageRequester("Result", "Maximum Window Width: " + Str(maxX) + ", Maximum Window Height: " + Str(maxY))
EndIf

; ------------------------------------------------------
; Sample output For a screen area 1600 x 1200:
; 
; Maximum Window Width: 1600, Maximum Window Height: 1181
; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 10
; EnableXP
; EnableUnicode