﻿;==================================================================
; Rosetta Task: GUI component interaction
;
; Almost every application needs to communicate with the user in some way. Therefore, a substantial
; part of the code deals with the interaction of program logic with GUI components.
; 
; Typically, the following is needed:
; 
; put values into input fields under program control
; read and check input from the user
; pop up dialogs to query the user for further information

; The task: for a minimal "application", write a program that presents a form with three components 
; To the user: a numeric input field ("Value") and two buttons ("increment" and "random").
; 
; The field is initialized to zero. The user may manually enter a new value into the field, or increment 
; its value with the "increment" button. Entering a non-numeric value should be either impossible, or issue an error message.
; 
; Pressing the "random" button presents a confirmation dialog, and resets the field's value to a random value if the answer is "Yes".
;==================================================================

Enumeration 
  #StringGadget
  #Increment
  #Random
EndEnumeration
 
If OpenWindow(0,#PB_Ignore,#PB_Ignore,180,50,"PB-GUI",#PB_Window_SystemMenu)
  StringGadget(#StringGadget,5,5,170,20,"",#PB_String_Numeric)
  ButtonGadget(#Increment,5,25,80,20, "Increment")
  ButtonGadget(#Random,  90,25,80,20, "Random")
  Repeat
    Event=WaitWindowEvent()
    If Event=#PB_Event_Gadget
      Select EventGadget()
        Case #Increment
          CurrentVal=Val(GetGadgetText(#StringGadget))
          SetGadgetText(#StringGadget,Str(CurrentVal+1))
        Case #Random
          Flag=#PB_MessageRequester_YesNo
          Answer=MessageRequester("Randomize","Are you sure?",Flag)
          If Answer=#PB_MessageRequester_Yes
            SetGadgetText(#StringGadget,Str(Random(#MAXLONG)))
          EndIf
      EndSelect
    EndIf
  Until Event=#PB_Event_CloseWindow
  CloseWindow(0)
EndIf
; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 18
; EnableXP
; EnableUnicode