﻿;==================================================================
; Rosetta Task: Grayscale image

; Many image processing algorithms are defined for grayscale (or else monochromatic) images. Extend the 
; data storage type defined on this page to support grayscale images. Define two operations, one to convert
; a color image to a grayscale image and one for the backward conversion. To get luminance of a color 
; use the formula recommended by CIE:
; 
; L = 0.2126·R + 0.7152·G + 0.0722·B
; 
; When using floating-point arithmetic make sure that rounding errors would not cause run-time problems 
; or else distorted results when calculated luminance is stored as an unsigned integer.
; ==================================================================

Procedure ImageGrayout(image)
  w = ImageWidth(image)
  h = ImageHeight(image)
  StartDrawing(ImageOutput(image))
  For x = 0 To w - 1
    For y = 0 To h - 1
      color = Point(x, y)
      r    = color & $ff
      g    = color >> 8 & $ff
      b    = color >> 16 & $ff
      gray = 0.2126*r + 0.7152*g + 0.0722*b
      Plot(x, y, gray + gray << 8 + gray << 16)
    Next
  Next
  StopDrawing()
EndProcedure
; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 5
; Folding = -
; EnableXP
; EnableUnicode