﻿;==================================================================
; Rosetta Task:  HTTP
;
; Access and print a URL's content (the located resource) to the console. There is a separate task for HTTPS Requests.
;==================================================================
 
InitNetwork()
OpenConsole()
 
tmpdir$   = GetTemporaryDirectory()
filename$ = tmpdir$ + "PB_tempfile" + Str(Random(200000)) + ".html"
 
If ReceiveHTTPFile("http://rosettacode.org/wiki/Main_Page", filename$)
  If ReadFile(1, filename$)
    Repeat
      PrintN(ReadString(1))
    Until Eof(1)
    Input()
    ; to prevent console from closing if on windows
    CloseFile(1)
  EndIf
  DeleteFile(filename$)
EndIf
 
; Another solution using general networking commands

;  
; InitNetwork()
; OpenConsole()
; id = OpenNetworkConnection("rosettacode.org", 80)
; SendNetworkString(id, "GET /wiki/Main_Page HTTP/1.1" + Chr(10) + "Host: rosettacode.org" + Chr(10) + Chr(10))
; Repeat
;   If NetworkClientEvent(id) = 2
;     a$ = Space(1000)
;     ReceiveNetworkData(id, @a$, 1000)
;     out$ + a$
;   EndIf
; Until FindString(out$, "</html>", 0)
; PrintN(out$)
; ; next line only to prevent console from closing on Windows
; Input()
;  
; IDE Options = PureBasic 5.41 LTS (Windows - x86)
; CursorPosition = 5
; EnableUnicode
; EnableXP