﻿;==================================================================
; Rosetta Task: Handle a signal

; Most general purpose operating systems provide interrupt facilities, sometimes called signals. Unhandled 
; signals generally terminate a program in a disorderly manner. Signal handlers are created so that the 
; program behaves in a well-defined manner upon receipt of a signal.

; For this task you will provide a program that displays a single integer on each line of output at the rate 
; of one integer in each half second. Upon receipt of the SigInt signal (often created by the user typing 
; ctrl-C) the program will cease printing integers to its output, print the number of seconds the program 
; has run, and then the program will terminate.
;==================================================================

;This code is for Windows only due to the usage of SetConsoleCtrlHandler()

CompilerIf #PB_Compiler_OS<>#PB_OS_Windows
  CompilerError "This code is Windows only"
CompilerEndIf
 
Global Quit, i, T0=ElapsedMilliseconds(), T1
 
Procedure CtrlC()
  T1=ElapsedMilliseconds()
  Quit=1
  While i: Delay(1): Wend 
EndProcedure
 
If OpenConsole() 
  SetConsoleCtrlHandler_(@CtrlC(),#True)  
  While Not Quit
    PrintN(Str(i))
    i+1
    Delay(50)
  Wend
  PrintN("Program has run for "+StrF((T1-T0)/1000,3)+" seconds.")
  Print ("Press ENTER to exit."):Input(): i=0
EndIf

;-Output
; 0
; 1
; 2
; 3
; 4
; Program has run For 2.121 seconds.
; Press ENTER To exit.
; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 13
; Folding = -
; EnableXP
; EnableUnicode