﻿;==================================================================
; Rosetta Task: Horizontal sundial calculations
;
; Create a program that calculates the hour, sun hour angle, dial hour line angle from 6am to 6pm 
; for an operator entered location.
;==================================================================

If OpenConsole()
  Define.f lat, slat, lng, ref
  Define.i h
  Print("Enter latitude       => "): lat=ValF(Input())
  Print("Enter longitude      => "): lng=ValF(Input())
  Print("Enter legal meridian => "): ref=ValF(Input())
  PrintN("")
 
  slat=Sin(lat*2*#PI/360)
  PrintN("    sine of latitude:   "+StrF(slat,3))
  PrintN("    diff longitude:     "+StrF((lng-ref),3)+#CRLF$)
  PrintN("Hour, sun hour angle, dial hour line angle from 6am to 6pm")
 
  For h=-6 To 6
    Define.f hra, hla
    hra=15*h
    hra=hra-(lng-ref)
    hla=ATan(slat*Tan(hra*2*#PI/360))*360/(2*#PI)
    PrintN("HR="+RSet(Str(h),3)+"; HRA="+RSet(StrF(hra,3),7)+"; HLA="+RSet(StrF(hla,3),7))
  Next
 Input()
EndIf

; Output:
; Enter latitude       => -4.95
; Enter longitude      => -150.5
; Enter legal meridian => -150
; 
;     sine of latitude:   -0.086
;     diff longitude:     -0.500
; 
; Hour, sun hour angle, dial hour line angle from 6am To 6pm
; HR= -6; HRA=-89.500; HLA= 84.225
; HR= -5; HRA=-74.500; HLA= 17.283
; HR= -4; HRA=-59.500; HLA=  8.334
; HR= -3; HRA=-44.500; HLA=  4.847
; HR= -2; HRA=-29.500; HLA=  2.795
; HR= -1; HRA=-14.500; HLA=  1.278
; HR=  0; HRA=  0.500; HLA= -0.043
; HR=  1; HRA= 15.500; HLA= -1.371
; HR=  2; HRA= 30.500; HLA= -2.910
; HR=  3; HRA= 45.500; HLA= -5.018
; HR=  4; HRA= 60.500; HLA= -8.671
; HR=  5; HRA= 75.500; HLA=-18.451
; HR=  6; HRA= 90.500; HLA= 84.225
; IDE Options = PureBasic 5.41 LTS (Windows - x86)
; CursorPosition = 27
; EnableUnicode
; EnableXP