﻿;==================================================================
; Rosetta Task:  I before E except after C
;
; The phrase "I before E, except after C" is a widely known mnemonic which is supposed to help when spelling English words.
;==================================================================

If ReadFile(1,GetPathPart(ProgramFilename())+"wordlist(en).txt")
  While Not Eof(1)
    wl$+ReadString(1)+";"
  Wend
  CloseFile(1)
EndIf
 
OpenConsole()
PrintN("Number of words in [wordlist(en).txt]: "+CountString(wl$,";"))
cei.i=CountString(wl$,"cei") : PrintN("Instances of [cei]                   : "+Str(cei))
cie.i=CountString(wl$,"cie") : PrintN("Instances of [cie]                   : "+Str(cie))
Print("Rule: 'e' before 'i' when preceded by 'c' is = ")
If cei>cie : PrintN("plausible") : Else : PrintN("not plausible") : EndIf
wl$=RemoveString(wl$,"cei")  : wl$=RemoveString(wl$,"cie")
PrintN("")
ei.i=CountString(wl$,"ei")   : PrintN("Instances of [*ei] '*'<>'c'          : "+Str(ei))
ie.i=CountString(wl$,"ie")   : PrintN("Instances of [*ie] '*'<>'c'          : "+Str(ie))
Print("Rule: 'i' before 'e' when not preceded by 'c' is = ")
If ie>ei : PrintN("plausible") : Else : PrintN("not plausible") : EndIf
PrintN("")
Print("Overall the rule is : ")
If cei>cie And ie>ei : PrintN("PLAUSIBLE") : Else : PrintN("NOT PLAUSIBLE") :  EndIf
Input()


; Output:
; Number of words in [wordlist(en).txt]: 25104
; Instances of [cei]                   : 13
; Instances of [cie]                   : 24
; Rule: 'e' before 'i' when preceded by 'c' is = Not plausible
; 
; Instances of [*ei] '*'<>'c'          : 217
; Instances of [*ie] '*'<>'c'          : 466
; Rule: 'i' before 'e' when Not preceded by 'c' is = plausible
; 
; Overall the rule is : Not PLAUSIBLE
; IDE Options = PureBasic 5.41 LTS (Windows - x86)
; CursorPosition = 1
; EnableUnicode
; EnableXP