﻿;==================================================================
; Rosetta Task: Iterated digits squaring
;
; If you add the square of the digits of a Natural number (an integer bigger than zero), 
; you always end with either 1 or 89:
; 
; 15 -> 26 -> 40 -> 16 -> 37 -> 58 -> 89
; 7 -> 49 -> 97 -> 130 -> 10 -> 1
;
; Task: Count how many number chains For integers 1 <= n < 100_000_000 end with a value 89.
;==================================================================

; Translation of 'C' language...

Define.i
OpenConsole()
Procedure is89(x)
  Repeat
    s=0
    While x : s+ x%10*x%10 : x/10 : Wend
    If s=89 : ProcedureReturn 1 : EndIf
    If s=1  : ProcedureReturn 0 : EndIf
    x=s
  ForEver
EndProcedure
 
Procedure main()
  Dim sums(32*81+1) : sums(0)=1 : sums(1)=0
 
  For n=1 To n+1
    For i=n*81 To 1 Step -1
      For j=1 To 9
        s=j*j : If s>i : Break : EndIf
        sums(i)+sums(i-s)
      Next
    Next
    count89=0
    For i=1 To n*81+1
      If Not is89(i) : Continue : EndIf
      If sums(i)>9223372036854775807-count89
        PrintN("counter overflow for 10^"+Str(n))
        ProcedureReturn 0
      EndIf
      count89+sums(i)
    Next
    PrintN("1->10^"+LSet(Str(n),2,Chr(32))+": "+Str(count89))
  Next  
EndProcedure
 
start=ElapsedMilliseconds()
main()
Print("elapsed milliseconds= "+Str(ElapsedMilliseconds()-start))
Input()

; Output:
; 1->10^1 : 7
; 1->10^2 : 80
; 1->10^3 : 857
; 1->10^4 : 8558
; 1->10^5 : 85623
; 1->10^6 : 856929
; 1->10^7 : 8581146
; 1->10^8 : 85744333
; 1->10^9 : 854325192
; 1->10^10: 8507390852
; 1->10^11: 84908800643
; 1->10^12: 850878696414
; 1->10^13: 8556721999130
; 1->10^14: 86229146720315
; 1->10^15: 869339034137667
; 1->10^16: 8754780882739336
; 1->10^17: 87975303595231975
; 1->10^18: 881773944919974509
; 1->10^19: 8816770037940618762
; counter overflow For 10^20
; elapsed milliseconds= 9
; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 9
; Folding = -
; EnableXP
; EnableUnicode