﻿;==================================================================
; Rosetta Task: JortSort
;
; JortSort is a function that takes a single array of comparable objects as its argument. It then sorts the 
; array in ascending order and compares the sorted array to the originally provided array. If the arrays match
;  (i.e. the original array was already sorted), the function returns true. If the arrays do not match 
; (i.e. the original array was not sorted), the function returns false.
;==================================================================

Macro isSort(liste)
  If OpenConsole()    
    Print("[ ") : ForEach liste : Print(liste+Space(1)) : Next : Print("] = ")
    If jortSort(liste) : PrintN("True") : Else : PrintN("False") : EndIf
  EndIf  
EndMacro
 
Procedure.b jortSort(List jortS.s())
  NewList cpy.s() : CopyList(jortS(),cpy()) : SortList(cpy(),#PB_Sort_Ascending)
  ForEach jortS()    
    SelectElement(cpy(),ListIndex(jortS()))
    If Not jortS()=cpy() : ProcedureReturn #False : EndIf
  Next  
  ProcedureReturn #True
EndProcedure
 
NewList l1.s()
For i=1 To 10 : AddElement(l1()) : l1()=Chr(Random(90,65)) : Next
isSort(l1()) : SortList(l1(),#PB_Sort_Ascending) : isSort(l1())
Input()

; Output:
; [ A Z Q G B N E B G Y ] = False
; [ A B B E G G N Q Y Z ] = True
; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 3
; Folding = -
; EnableXP
; EnableUnicode