﻿;==================================================================
; Rosetta Task: Keyboard macros
;
; Show how to link user defined methods to user defined keys. An example of this is the facility provided 
; by emacs for key bindings. These key bindings may be application-specific or system-wide; state which 
; you have done.
;==================================================================

; PureBasic has support for shortcut/macro creation in any window that supports events. This allows for 
; creation of both single and combinations as shown in the code below. For full set of combinations on 
; PC, Mac & Linux please see the official manual.

#Win   = 0
#Demo1 = 0
#Demo2 = 1
 
If OpenWindow(#Win,50,50,200,60,"PureBasic",#PB_Window_SystemMenu)
  ;
  AddKeyboardShortcut(#Win,#PB_Shortcut_F1, #Demo1)
  AddKeyboardShortcut(#Win,#PB_Shortcut_F|#PB_Shortcut_Alt, #Demo2)
  ;
  Repeat
    WEvent = WaitWindowEvent()
    Select  WEvent
      Case #PB_Event_Menu
        Select EventMenu()
          Case #Demo1
            MessageRequester("Info", "You Pressed F1")
 
          Case #Demo2
            MessageRequester("Info", "You Pressed Alt-F")
 
        EndSelect
      Case #PB_Event_CloseWindow
        Break
    EndSelect
  ForEver
EndIf
; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 9
; EnableXP
; EnableUnicode