﻿;==================================================================
; Rosetta Task: Knuth shuffle
;
; Implement the Knuth shuffle (a.k.a. the Fisher-Yates shuffle) for an integer array (or, if possible, an 
; array of any type). The Knuth shuffle is used to create a random permutation of an array.
;==================================================================

EnableExplicit
 
Procedure KnuthShuffle(Array a(1))
   Protected i, last = ArraySize(a())
 
   For i = last To 1 Step -1
      Swap a(i), a(Random(i)) 
   Next 
EndProcedure
 
Procedure.s ArrayToString(Array a(1))
   Protected ret$, i, last = ArraySize(a())
 
   ret$ = Str(a(0))
   For i = 1 To last
      ret$ + "," + Str(a(i))
   Next
   ProcedureReturn ret$
EndProcedure
 
 
#NumElements = 10
 
Dim a(#NumElements-1)
Define i
 
For i = 0 To #NumElements-1
   a(i) = i
Next
 
KnuthShuffle(a())
Debug "shuffled: " + ArrayToString(a())

; Output:
; shuffled: 1,8,6,0,5,9,2,4,7,3
; IDE Options = PureBasic 5.41 LTS (Windows - x86)
; CursorPosition = 39
; Folding = -
; EnableUnicode
; EnableXP