﻿;==================================================================
; Rosetta Task: Letter frequency
;
; Open a text file and count the occurrences of each letter.

; Some of these programs count all characters (including punctuation), but some only count letters A To Z.
;==================================================================

; Alphabetic codes are converted to uppercase before being used and no other codes are used as part of the calculations. 

Procedure countLetters(Array letterCounts(1), textLine.s)
  ;counts only letters A -> Z, uses index 0 of letterCounts() to keep a total of all counts
  Protected i, lineLength = Len(textLine), letter
 
  textLine = UCase(textLine)
  For i = 1 To lineLength
    letter = Asc(Mid(textLine, i, 1)) - 'A' + 1
    If letter >= 1 And letter <= 26
      letterCounts(letter) + 1 ;tally individual letter count
      letterCounts(0) + 1      ;increment total letter count
    EndIf
  Next
EndProcedure
 
If OpenConsole()
  Define filename.s, fileID, i
  filename = OpenFileRequester("Select text file to examine", "*.txt", "Text (*.txt)|*.txt;|All files (*.*)|*.*", 0)
  fileID = 0
  If ReadFile(fileID, filename)
    Dim letterCounts(26) ;A - Z only, index 0 contains the total of all letter counts
 
    Define textLine.s
    While Not Eof(fileID)
      textLine = ReadString(fileID)
      countLetters(letterCounts(), textLine)
    Wend
    CloseFile(fileID)
 
    PrintN("File: " + filename + #CRLF$)
    PrintN("Letter  %Freq  Count")
    For i = 1 To 26
      Print("  " + Chr(64 + i) + "     ")
      Print(RSet(StrF(100 * letterCounts(i) / letterCounts(0), 1), 5, " ") + "  ")
      PrintN(Str(letterCounts(i)))
    Next 
    PrintN(#CRLF$ + "Total letter count in file: " + Str(letterCounts(0)))
  EndIf 
 
  Print(#CRLF$ + #CRLF$ + "Press ENTER to exit"): Input()
  CloseConsole()
EndIf
; Output:
; File: D:\_T\Text\dictionary.txt
; 
; Letter  %Freq  Count
;   A       7.6  27743
;   B       2.0  7248
;   C       4.3  15433
;   D       3.8  13798
;   E      11.8  42917
;   F       1.4  5030
;   G       2.8  10336
;   H       2.1  7720
;   I       8.6  31141
;   J       0.2  588
;   K       0.8  2964
;   L       5.3  19399
;   M       2.7  9821
;   N       7.1  25682
;   O       6.1  22084
;   P       2.9  10696
;   Q       0.2  714
;   R       7.5  27055
;   S       8.0  28898
;   T       7.1  25773
;   U       3.3  12032
;   V       1.1  4019
;   W       0.9  3348
;   X       0.3  1096
;   Y       1.7  6251
;   Z       0.3  1177
; 
; Total letter count in file: 362963
; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 8
; Folding = -
; EnableXP
; EnableUnicode