﻿;==================================================================
; Rosetta Task: Literals
;
; Programming languages have different ways of expressing floating-point literals. Show how floating-point 
; literals can be expressed in your language: decimal or other bases, exponential notation, and any other special features.
;==================================================================

; #1 - Floating point literals

; Floating point literals do not need a decimal point if an exponent is used.
; They may also include a sign For the number or exponent.
;Displayed....  -1.0   1.0  1.0E2  1.0E+2  1.0E-2  -1E2

; #2 - Integers
; PureBasic allows integer literals to be specified in base 10, base 2 by using the prefix '%', or base 16 by using the prefix '$'.
; 
; x = 15     ;15 in base 10
; x = %1111  ;15 in base 2
; x = $f     ;15 in base 16
; An integer literal representing a character code can also be expressed by surrounding the character with 
; single quotes. More than one character can be included in the single quotes (i.e. 'abc'). Depending on whether 
; code is compiled in Ascii or Unicode mode this will result in the integer value being specified in base 256 Or base 65536 respectively.
; 
; x = 'a'     ;129

; #3 - String Literals (characters and strings)
; show how verbatim strings (quotes where escape sequences are quoted literally) and here-strings work. 
; Also, discuss which quotes expand variables.
; --------------------------------------------------------

;PureBasic supports char in ASCII And UNICODE as well as both dynamic and fixed length strings.

; Characters (*.c), can be ASCII or UNICODE depending on compiler setting
Define.c  AChar='A'
; defines as *.a it will be ASCII and *.u is always UNICODE
Define.a  A='b'
Define.u  U='水'
 
; Strings is defined as **.s or ending with '$'
Define.s  AStrion     ="String #1"
Define    BStrion.s   ="String #2"
Define    CString$    ="String #3"
; Fixed length stings can be defined if needed
Define XString.s{100} ="I am 100 char long!"
 
; '"' can be included via CHR() or its predefined constant
Define AStringQuotes$=Chr(34)+"Buu"+Chr(34)+" said the ghost!"
Define BStringQuotes$=#DOUBLEQUOTE$+"Buu"+#DOUBLEQUOTE$+" said yet a ghost!"

;To dynamically detect the current sizes of a character, e.g. ASCI Or UNICODE mode, StringByteLength() can be used.
OpenConsole()

Select StringByteLength("X")
  Case 1
    Print("ASCII-mode;  Soo, Hello world!")
  Case 2
    Print("UNICODE-mode; Soo, 您好世界!")
EndSelect
Input()

; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 30
; FirstLine = 12
; EnableXP
; EnableUnicode