﻿;==================================================================
; Rosetta Task: Longest common subsequence
;
; The longest common subsequence (or LCS) of groups A and B is the longest group of elements from A 
; and B that are common between the two groups and in the same order in each group. For example, the
; sequences "1234" and "1224533324" have an LCS of "1234":
;==================================================================

Procedure.s lcs(a$, b$)
  Protected x$ , lcs$
  If Len(a$) = 0 Or Len(b$) = 0 
    lcs$ = ""
  ElseIf Right(a$, 1) = Right(b$, 1) 
    lcs$ = lcs(Left(a$, Len(a$) - 1), Left(b$, Len(b$) - 1)) + Right(a$, 1)
  Else
    x$ = lcs(a$, Left(b$, Len(b$) - 1))
    y$ = lcs(Left(a$, Len(a$) - 1), b$)
    If Len(x$) > Len(y$) 
      lcs$ = x$
    Else
      lcs$ = y$
    EndIf
  EndIf
  ProcedureReturn lcs$
EndProcedure

OpenConsole()
PrintN( lcs("thisisatest", "testing123testing"))
PrintN("Press any key to exit"): Repeat: Until Inkey() <> ""
; IDE Options = PureBasic 5.41 LTS (Windows - x86)
; CursorPosition = 28
; Folding = -
; EnableUnicode
; EnableXP