﻿;==================================================================
; Rosetta Task: Loop over multiple arrays simultaneously
;
; Loop over multiple arrays (or lists or tuples or whatever they're called in your language) and print the ith 
; element of each. Use your language's "for each" loop if it has one, otherwise iterate through 
; the collection in order with some other loop.

; For this example, loop over the arrays (a,b,c), (A,B,C) And (1,2,3) To produce the output
; 
; aA1
; bB2
; cC3
;==================================================================

OpenConsole()
; Fill arrays
Dim a.s(2)
Dim b.s(2)
Dim c(2)
For Arrayposition = 0 To ArraySize(a())
  a(Arrayposition) = Chr(Asc("a") + Arrayposition)
  b(Arrayposition) = Chr(Asc("A") + Arrayposition)
  c(Arrayposition) = Arrayposition + 1
Next
; loop over them
For Arrayposition = 0 To ArraySize(a())
  PrintN(a(Arrayposition) + b(Arrayposition) + Str(c(Arrayposition)))
Next
Input() ;wait for Enter before ending

; If they have different lengths there are two cases:
; a() is the shortest one: Only elements up to maximum index of a() are printed 
; a() is bigger than another one: If exceeding index to much, program crashes, 
; Else it may work because there is some "free space" after end of assigned array memory. 
; For example if a has size 4, line dD4 will also be printed. size 20 leads to a crash 
; This is because ReDim becomes slow if everytime there is a change to array size new memory has to be allocated.
; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 35
; EnableXP
; EnableUnicode