﻿;==================================================================
; Rosetta Task: Lucas-Lehmer test
;
; Lucas-Lehmer Test: for {p}  an odd prime, the Mersenne number {2^{p}-1}  is prime if and only 
; if {2^{p}-1}  divides {S(p-1)}  where {S(n+1)=(S(n))^{2}-2} , and {S(1)=4}.

; The following programs calculate all Mersenne primes up to the implementation's maximum precision, 
; or the 47th Mersenne prime. (which ever comes first).
;==================================================================

; PureBasic has no large integer support. Calculations are limited to the range of a signed quad integer type.

Procedure Lucas_Lehmer_Test(p)
  Protected mp.q = (1 << p) - 1, sn.q = 4, i
  For i = 3 To p
    sn = (sn * sn - 2) % mp
  Next
  If sn = 0
    ProcedureReturn #True
  EndIf
  ProcedureReturn #False
EndProcedure
 
#upperBound = SizeOf(Quad) * 8 - 1 ;equivalent to significant bits in a signed quad integer
If OpenConsole()
  Define p = 3
  PrintN("M2")
  While p <= #upperBound
    If Lucas_Lehmer_Test(p)
      PrintN("M" + Str(p))
    EndIf
    p + 2
  Wend
 
  Print(#CRLF$ + #CRLF$ + "Press ENTER to exit"): Input()
  CloseConsole()
EndIf

; Output:
; M2
; M3
; M5
; M7
; M13
; M17
; M19
; M31
; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 10
; Folding = -
; EnableXP
; EnableUnicode