﻿;==================================================================
; Rosetta Task: Map range
;
;The task is to write a function/subroutine/... that takes two ranges and a real number, and returns the 
; mapping of the real number from the first to the second range.
;==================================================================

Structure RR
  a.f
  b.f
EndStructure
 
Procedure.f MapRange(*a.RR, *b.RR, s)
  Protected.f a1, a2, b1, b2 
  a1=*a\a:  a2=*a\b
  b1=*b\a:  b2=*b\b
  ProcedureReturn b1 + ((s - a1) * (b2 - b1) / (a2 - a1))
EndProcedure
 
 
;- Test the function
If OpenConsole()
  Define.RR Range1, Range2
  Range1\a=0: Range1\b=10
  Range2\a=-1:Range2\b=0
  ;
  For i=0 To 10
    PrintN(RSet(Str(i),2)+" maps to "+StrF(MapRange(@Range1, @Range2, i),1))
  Next
EndIf
Input()
;  0 maps To -1.0
;  1 maps To -0.9
;  2 maps To -0.8
;  3 maps To -0.7
;  4 maps To -0.6
;  5 maps To -0.5
;  6 maps To -0.4
;  7 maps To -0.3
;  8 maps To -0.2
;  9 maps To -0.1
; 10 maps To 0.0
; IDE Options = PureBasic 5.42 Beta 1 LTS (Windows - x86)
; CursorPosition = 30
; Folding = -
; EnableUnicode
; EnableXP