﻿;==================================================================
; Rosetta Task: Menu
;
; Given a prompt and a list containing a number of strings of which one is to be selected, create a function that:
; 
; prints a textual menu formatted as an index value followed by its corresponding string for each item in the list;
; prompts the user to enter a number;
; returns the string corresponding to the selected index number.
; The function should reject input that is not an integer or is out of range by redisplaying the whole menu before 
; asking again for a number. The function should return an empty string if called with an empty List.
; 
; For test purposes use the four phrases: “fee fie”, “huff And puff”, “mirror mirror” and “tick tock” in a list.
; 
; Note: This task is fashioned after the action of the Bash select statement.
;==================================================================

If OpenConsole()
  Define i, txt$, choice
  Dim txts.s(4)
  EnableGraphicalConsole(1)  ;- Enable graphical mode in the console
  Repeat
    ClearConsole()
    Restore TheStrings       ; Set reads address
    For i=1 To 4
      Read.s  txt$
      txts(i)=txt$
      ConsoleLocate(3,i): Print(Str(i)+": "+txt$)
    Next
    ConsoleLocate(3,6): Print("Your choice? ")
    choice=Val(Input())
  Until choice>=1 And choice<=4
  ClearConsole()
  ConsoleLocate(3,2): Print("You chose: "+txts(choice))
  ;
  ;-Now, wait for the user before ending to allow a nice presentation
  ConsoleLocate(3,5): Print("Press ENTER to quit"): Input()
EndIf
End
 
DataSection
  TheStrings:
  Data.s  "fee fie", "huff And puff", "mirror mirror", "tick tock"
EndDataSection
; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 13
; EnableXP
; EnableUnicode