﻿;==================================================================
; Rosetta Task: Miller–Rabin primality test
;
; The Miller–Rabin primality test or Rabin–Miller primality test is a primality test: an algorithm which 
; determines whether a given number is prime or not.
;==================================================================

Enumeration 
  #Composite
  #Probably_prime
EndEnumeration
 
Procedure Miller_Rabin(n, k)
  Protected d=n-1, s, x, r
  If n=2
    ProcedureReturn #Probably_prime
  ElseIf n%2=0 Or n<2
    ProcedureReturn #Composite
  EndIf
  While d%2=0
    d/2
    s+1
  Wend
  While k>0
    k-1
    x=Int(Pow(2+Random(n-4),d))%n
    If x=1 Or x=n-1: Continue: EndIf
    For r=1 To s-1
      x=(x*x)%n
      If x=1: ProcedureReturn #Composite: EndIf
      If x=n-1: Break: EndIf
    Next
    If x<>n-1: ProcedureReturn #Composite: EndIf 
  Wend
  ProcedureReturn #Probably_prime
EndProcedure
; IDE Options = PureBasic 5.42 Beta 1 LTS (Windows - x86)
; CursorPosition = 1
; Folding = -
; EnableUnicode
; EnableXP