﻿;==================================================================
; Rosetta Task: Monty Hall problem
;
; Run random simulations of the Monty Hall game. Show the effects of a strategy of the contestant 
; always keeping his first guess so it can be contrasted with the strategy of the contestant always switching his guess.
;==================================================================

Structure wins
  stay.i
  redecide.i
EndStructure
 
#goat = 0
#car = 1
Procedure MontyHall(*results.wins)
  Dim Doors(2)
  Doors(Random(2)) = #car
 
  player = Random(2)
  Select Doors(player)
    Case #car
      *results\redecide + #goat
      *results\stay + #car
    Case #goat
      *results\redecide + #car
      *results\stay + #goat
  EndSelect
EndProcedure
 
OpenConsole()
#Tries = 1000000
 
Define results.wins
 
For i = 1 To #Tries
  MontyHall(@results)
Next
 
PrintN("Trial runs for each option: " + Str(#Tries))
PrintN("Wins when redeciding: " + Str(results\redecide) + " (" + StrD(results\redecide / #Tries * 100, 2) + "% chance)")
PrintN("Wins when sticking:   " + Str(results\stay) + " (" + StrD(results\stay / #Tries * 100, 2) + "% chance)")
Input()

; Output:
; Trial runs For each option: 1000000
; Wins when redeciding: 666459 (66.65% chance)
; Wins when sticking:   333541 (33.35% chance)
; IDE Options = PureBasic 5.42 Beta 1 LTS (Windows - x86)
; CursorPosition = 42
; FirstLine = 11
; Folding = -
; EnableUnicode
; EnableXP