﻿;==================================================================
; Rosetta Task: Multiple distinct objects
;
; Create a sequence (array, list, whatever) consisting of n distinct, initialized items of the same type. 
; n should be determined at runtime.
;==================================================================

n=Random(50)+25
Dim A.i(n)  
; Creates a array of n [25-75] elements depending on the outcome of Random().
; Each element will be initiated to zero.
 
For i=0 To ArraySize(A())
  A(i)=2*i
Next i
; Set each individual element at a wanted (here 2*i) value and 
; automatically adjust accordingly to the unknown length of the array.
 
NewList *PointersToA()
For i=0 To ArraySize(A())
  AddElement(*PointersToA())
  *PointersToA()=@A(i)
Next
; Create a linked list of the same length as A() above.
; Each element is then set to point to the array element
; of the same order.
 
ForEach *PointersToA()
  Debug PeekI(*PointersToA())
Next
; ----------------------------
; Verify by sending each value of A() via *PointersToA()
; to the debugger's output.
; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 16
; EnableXP
; EnableUnicode