﻿;==================================================================
; Rosetta Task: Non-decimal radices - Convert
;
; Number base conversion is when you express a stored integer in an integer base, such as in octal (base 8) 
; or binary (base 2). It also is involved when you take a string representing a number in a given base and 
; convert it to the stored integer form. Normally, a stored integer is in binary, but that's typically invisible 
; to the user, who normally enters or sees stored integers as decimal.
;
; Write a function (or identify the built-in function) which is passed a non-negative integer to convert, and
; another integer representing the base. It should return a string containing the digits of the resulting
; number, without leading zeros except for the number 0 itself. For the digits beyond 9, one should use the
; lowercase English alphabet, where the digit a = 9+1, b = a+1, etc. The decimal number 26 expressed 
; in base 16 would be 1a, for example.
;==================================================================

Global alphanum$ = "0123456789abcdefghijklmnopqrstuvwxyz" ;36 digits
#maxIntegerBitSize = SizeOf(Integer) * 8
 
Procedure toDecimal(base, s.s)
  Protected length, i, toDecimal
 
  length = Len(s)
  If length: toDecimal = FindString(alphanum$, Left(s, 1), 1) - 1: EndIf 
 
  For i = 2 To length
    toDecimal * base + FindString(alphanum$, Mid(s, i, 1), 1) - 1
  Next
  ProcedureReturn toDecimal
EndProcedure
 
Procedure.s toBase(base, number)
  Protected i, rem, toBase.s{#maxIntegerBitSize} = Space(#maxIntegerBitSize) 
 
  For i = #maxIntegerBitSize To 1 Step -1
    rem = number % base
    PokeC(@toBase + i - 1, PeekC(@alphanum$ + rem))
    If number < base: Break: EndIf 
    number / base
  Next
  ProcedureReturn LTrim(toBase)
EndProcedure
 
If OpenConsole()
  PrintN( Str(toDecimal(16, "1a")) )
 
  PrintN( toBase(16, 26) )
 
  Print(#CRLF$ + #CRLF$ + "Press ENTER to exit")
  Input()
  CloseConsole()
EndIf

; Sample output:
; 
; 26
; 1a
; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 12
; Folding = -
; EnableXP