﻿;==================================================================
; Rosetta Task: Nth root
;
; Implement the algorithm to compute the principal nth root of a positive real number A.
;==================================================================

#Def_p=0.001
 
Procedure.d Nth_root(n.i, A.d, p.d=#Def_p)
  Protected Dim x.d(1) 
  x(0)=A: x(1)=A/n
  While Abs(x(1)-x(0))>p
    x(0)=x(1)
    x(1)=((n-1.0)*x(1)+A/Pow(x(1),n-1.0))/n
  Wend
  ProcedureReturn x(1)
EndProcedure
 
;//////////////////////////////
Debug "125'th root of 5642 is:"
Debug Pow(5642,1/125)
Debug "------------"
Debug "First estimate is:"
Debug Nth_root(125,5642)
Debug "------------"
Debug "And better:"
Debug Nth_root(125,5642,0.00001)
Debug "------------"

; Outputs
; 
; 125'th root of 5642 is
; 1.0715475919447675
; First estimate is:
; 1.0715596021916822
; And better:
; 1.0715475919447714
; IDE Options = PureBasic 5.42 Beta 1 LTS (Windows - x86)
; CursorPosition = 19
; Folding = -
; EnableUnicode
; EnableXP