﻿;==================================================================
; Rosetta Task: One of n lines in a file
;
; Task..
; Create a function/method/routine called one_of_n that given n, the number of actual lines in a file, follows
; the algorithm above to return an integer - the line number of the line chosen from the file. 
; The number returned can vary, randomly, in each run.
; Use one_of_n in a simulation to find what woud be the chosen line of a 10 line file simulated 1,000,000 times.
; Print and show how many times each of the 10 lines is chosen as a rough measure of how well the algorithm works.
; Note: You may choose a smaller number of repetitions If necessary, but mention this up-front.
;==================================================================

Procedure.f randomFloat()
   ProcedureReturn Random(1000000) / 1000000
EndProcedure
 
Procedure one_of_n(n)
  Protected linesRead, lineChosen
  While linesRead < n 
    linesRead + 1
    If randomFloat() <= (1.0 / (linesRead))
       lineChosen = linesRead
    EndIf
  Wend
  ProcedureReturn lineChosen
EndProcedure
 
If OpenConsole()
  #testFileLineCount = 10
  #simulationCount = 1000000
  Define i
  Dim a(#testFileLineCount) ;index 0 is not used
  For i = 1 To #simulationCount
    x = one_of_n(#testFileLineCount)
    a(x) + 1
  Next
 
  For i = 1 To #testFileLineCount
    Print(Str(a(i)) + "  ")
  Next
  PrintN("")
 
  Print(#CRLF$ + #CRLF$ + "Press ENTER to exit"): Input()
  CloseConsole()
EndIf
; Sample output:
; 
; 99959  100011  100682  100060  99834  99632  100083  99817  99824  100098
; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 8
; Folding = -
; EnableXP
; EnableUnicode