﻿;==================================================================
; Rosetta Task: One-dimensional cellular automata
;
; Assume an array of cells with an initial distribution of live and dead cells, and imaginary cells off the 
; end of the array having fixed values.

; Cells in the next generation of the array are calculated based on the value of the cell and its left and 
; right nearest neighbours in the current generation.
;==================================================================

EnableExplicit
Dim cG.i(21) 
Dim nG.i(21)
Define.i n, Gen
 
DataSection
  Data.i 0,1,1,1,0,1,1,0,1,0,1,0,1,0,1,0,0,1,0,0
EndDataSection
For n=1 To 20
  Read.i cG(n)
Next
 
OpenConsole()
Repeat
  Print("Generation "+Str(Gen)+": ")
  For n=1 To 20
    Print(Chr(95-cG(n)*60))
  Next
  Gen +1
  PrintN("")
  For n=1 To 20
    If (cG(n) And (cG(n-1) XOr cg(n+1))) Or (Not cG(n) And (cG(n-1) And cg(n+1)))
     nG(n)=1
   Else
     nG(n)=0   
   EndIf    
  Next 
  CopyArray(nG(), cG())
Until Gen > 9
 
PrintN("Press any key to exit"): Repeat: Until Inkey() <> ""

; Output:
; Generation 0: _###_##_#_#_#_#__#__
; Generation 1: _#_#####_#_#_#______
; Generation 2: __##___##_#_#_______
; Generation 3: __##___###_#________
; Generation 4: __##___#_##_________
; Generation 5: __##____###_________
; Generation 6: __##____#_#_________
; Generation 7: __##_____#__________
; Generation 8: __##________________
; Generation 9: __##________________
; IDE Options = PureBasic 5.41 LTS (Windows - x64)
; CursorPosition = 37
; EnableUnicode
; EnableXP