﻿;==================================================================
; Rosetta Task: Ordered words
;
; Define an ordered word as a word in which the letters of the word appear in alphabetic order. 
; Examples include 'abbey' and 'dirt'.

; The task is to find and display all the ordered words in this dictionary that have the longest word 
; length. (Examples that access the dictionary file locally assume that you have downloaded this file 
; yourself.) The display needs to be shown on this page.
;==================================================================

Procedure.s sortLetters(*word.Character, wordLength) ;returns a string with the letters of a word sorted
  Protected Dim letters.c(wordLength)
  Protected *letAdr = @letters()
 
  CopyMemoryString(*word, @*letAdr)
  SortArray(letters(), #PB_Sort_Ascending, 0, wordLength - 1)
  ProcedureReturn PeekS(@letters(), wordLength)
EndProcedure
 
Structure orderedWord
  word.s
  length.i
EndStructure
 
Define filename.s = "unixdict.txt", fileNum = 0,  word.s
 
If OpenConsole()
  NewList orderedWords.orderedWord()
  If ReadFile(fileNum, filename)
    While Not Eof(fileNum)
      word = ReadString(fileNum)
      If word = sortLetters(@word, Len(word))
        AddElement(orderedWords())
        orderedWords()\word = word
        orderedWords()\length = Len(word)
      EndIf
    Wend
  Else
    MessageRequester("Error", "Unable to find dictionary '" + filename + "'")
    End
  EndIf
 
  SortStructuredList(orderedWords(), #PB_Sort_Ascending, OffsetOf(orderedWord\word), #PB_String)
  SortStructuredList(orderedWords(), #PB_Sort_Descending, OffsetOf(orderedWord\length), #PB_Integer)
  Define maxLength
  FirstElement(orderedWords())
  maxLength = orderedWords()\length
  ForEach orderedWords()
    If orderedWords()\length = maxLength
      Print(orderedWords()\word + "  ")
    EndIf
  Next 
 
  Print(#CRLF$ + #CRLF$ + "Press ENTER to exit"): Input()
  CloseConsole()
EndIf

; Sample output:
; 
; abbott  accent  accept  access  accost  almost  bellow  billow  biopsy  chilly
; choosy  choppy  effort  floppy  glossy  knotty
; IDE Options = PureBasic 5.42 LTS (Windows - x86)
; CursorPosition = 6
; Folding = -
; EnableUnicode
; EnableXP