﻿;==================================================================
; Rosetta Task: Pangram checker
;
; Write a function or method to check a sentence to see if it is a pangram (or not) and show its use.

; A pangram is a sentence that contains all the letters of the English alphabet at least once
; For example: The quick brown fox jumps over the lazy dog.
;==================================================================

Procedure IsPangram_fast(String$)
  String$ = LCase(string$)
  char_a=Asc("a")
  ; sets bits in a variable if a letter is found, reads string only once
  For a = 1 To Len(string$)
    char$ = Mid(String$, a, 1)
    pos   = Asc(char$) - char_a
    check.l |  1 << pos
  Next
  If check & $3FFFFFF = $3FFFFFF
    ProcedureReturn 1
  EndIf
  ProcedureReturn 0
EndProcedure
 
Procedure IsPangram_simple(String$)
  String$ = LCase(string$)
  found   = 1
  For a = Asc("a") To Asc("z")
  ; searches for every letter in whole string
    If FindString(String$, Chr(a), 0) = 0
      found = 0
    EndIf
  Next
  ProcedureReturn found
EndProcedure
 
Debug IsPangram_fast("The quick brown fox jumps over lazy dogs.")
Debug IsPangram_simple("The quick brown fox jumps over lazy dogs.")
Debug IsPangram_fast("No pangram")
Debug IsPangram_simple("No pangram")
; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 3
; Folding = -
; EnableXP
; EnableUnicode