﻿;==================================================================
; Rosetta Task: Permutations - Derangements
;
; A derangement is a permutation of the order of distinct items in which no item appears in its original place.

; For example, the only two derangements of the three items (0, 1, 2) are (1, 2, 0), And (2, 0, 1)
;==================================================================

; Brute Force: Tested up To n=10
 
Procedure.q perm(n)
If n=0:ProcedureReturn 1:EndIf
If n=1:ProcedureReturn 0:EndIf
ProcedureReturn (perm(n-1)+perm(n-2))*(n-1)
EndProcedure
 
factFile.s="factorials.txt"
tempFile.s="temp.txt"
drngFile.s="derangements.txt"
DeleteFile(factFile.s)
DeleteFile(tempFile.s)
DeleteFile(drngFile.s)
 
n=4
 
; create our storage file
f.s=factFile.s
If CreateFile(999,f.s)
WriteStringN(999,"1.2")
WriteStringN(999,"2.1")
CloseFile(999)
Else
Debug "not createfile :"+f.s
EndIf
 
showfactorial=#False
 
If showfactorial
; cw("nfactorial n ="+str(n))
Debug "nfactorial n ="+Str(n)
EndIf
 
; build up the factorial combinations
For l=1 To n-2
Gosub nfactorial
Next
 
; extract the derangements
; cw("derangements["+str(perm(n))+"] for n="+str(n))
Debug "derangements["+Str(perm(n))+"] for n="+Str(n)
Gosub derangements
; cw("")
Debug ""
 
; show the first 20 derangements
For i=0 To 20
; cw("derangements["+str(perm(i))+"] for n="+str(i))
Debug "derangements["+Str(perm(i))+"] for n="+Str(i)
Next
End
 
derangements:
x=0
If ReadFile(998,factFile.s) And CreateFile(999,drngFile.s)
Repeat
r.s = ReadString(998)
cs=CountString(r.s,".")
If cs
hit=0
t.s=""
; scan for numbers at their index
For i=1 To cs+1
s.s=StringField(r.s,i,".")
t.s+s.s+"."
If Val(s.s)=i:hit+1:EndIf
Next
t.s=RTrim(t.s,".")
; show only those which are valid
If Not hit
x+1
; cw(t.s+" "+str(x))
Debug t.s+" "+Str(x)
WriteStringN(999,t.s+" "+Str(x))
EndIf
EndIf
Until Eof(998)
CloseFile(998)
CloseFile(999)
Else
Debug "not readfile :"+factFile.s
Debug "not createfile :"+drngFile.s
EndIf
; cw("")
Debug ""
Return
 
nfactorial:
x=0
If ReadFile(998,factFile.s) And CreateFile(999,tempFile.s)
Repeat
r.s = ReadString(998)
cs=CountString(r.s,".")
If cs
For j=1 To cs+2
t.s=""
For i=1 To cs+1
s.s=StringField(r.s,i,".")
If i=j
t.s+"."+Str(cs+2)+"."+s.s
Else
t.s+"."+s.s
EndIf
Next
If j=cs+2:t.s+"."+Str(cs+2):EndIf
t.s=Trim(t.s,".")
x+1
If cs+2=n And showfactorial
; cw(t.s+" "+str(x))
Debug t.s+" "+Str(x)
EndIf
WriteStringN(999,t.s)
Next
EndIf
Until Eof(998)
CloseFile(998)
CloseFile(999)
Else
Debug "not readfile :"+factFile.s
Debug "not createfile :"+tempFile.s
EndIf
CopyFile(tempFile.s,factFile.s)
DeleteFile(tempFile.s)
Return
 
; Output:
; derangements[9] For n=4
; 4.3.1.2 1
; 3.4.1.2 2
; 3.1.4.2 3
; 4.1.2.3 4
; 4.3.2.1 5
; 3.4.2.1 6
; 2.3.4.1 7
; 2.4.1.3 8
; 2.1.4.3 9
; 
; derangements[1] For n=0
; derangements[0] For n=1
; derangements[1] For n=2
; derangements[2] For n=3
; derangements[9] For n=4
; derangements[44] For n=5
; derangements[265] For n=6
; derangements[1854] For n=7
; derangements[14833] For n=8
; derangements[133496] For n=9
; derangements[1334961] For n=10
; derangements[14684570] For n=11
; derangements[176214841] For n=12
; derangements[2290792932] For n=13
; derangements[32071101049] For n=14
; derangements[481066515734] For n=15
; derangements[7697064251745] For n=16
; derangements[130850092279664] For n=17
; derangements[2355301661033953] For n=18
; derangements[44750731559645106] For n=19
; derangements[895014631192902121] For n=20
; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 5
; Folding = -
; EnableXP
; EnableUnicode