﻿;==================================================================
; Rosetta Task: Power set
;
; A set is a collection (container) of certain values, without any particular order, and no repeated values. 
; It corresponds with a finite set in mathematics. A set can be implemented as an associative array
; (partial mapping) in which the value of each key-value pair is ignored.
;==================================================================

If OpenConsole()
  Define argc=CountProgramParameters()
  If argc>=(SizeOf(Integer)*8) Or argc<1
    PrintN("Set out of range.")
    End 1
  Else
    Define i, j, text$
    Define.q bset=1<<argc
    Print("{")
    For i=0 To bset-1   ; check all binary combinations
      If Not i: text$=  "{"
      Else    : text$=", {"
      EndIf
      k=0
      For j=0 To argc-1  ; step through each bit   
        If i&(1<<j)
          If k: text$+", ": EndIf         ; pad the output 
          text$+ProgramParameter(j): k+1  ; append each matching bit 
        EndIf
      Next j
      Print(text$+"}")
    Next i
    PrintN("}")
 
    EndIf
Input()
EndIf

; Output:
; C:\Users\PureBasic_User\Desktop>"Power Set.exe" 1 2 3 4
; {{}, {1}, {2}, {1, 2}, {3}, {1, 3}, {2, 3}, {1, 2, 3}, {4}, {1, 4},
; {2, 4}, {1, 2, 4}, {3, 4}, {1, 3, 4}, {2, 3, 4}, {1, 2, 3, 4}}
; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 32
; EnableXP
; EnableUnicode