﻿;==================================================================
; Rosetta Task: Primality by trial division
;
; Write a boolean function that tells whether a given integer is prime. Remember that 1 and all non-positive numbers are not prime.
; Use trial division. Even numbers over two may be eliminated right away. A loop from 3 To √n will suffice, but other loops are allowed.
;==================================================================

Procedure.i IsPrime(n)
   Protected k
 
   If n = 2
      ProcedureReturn #True
   EndIf   
 
   If n <= 1 Or n % 2 = 0
      ProcedureReturn #False
   EndIf
 
   For k = 3 To Int(Sqr(n)) Step 2
      If n % k = 0
         ProcedureReturn #False
      EndIf
   Next
 
   ProcedureReturn #True
EndProcedure

Debug IsPrime(12)
Debug IsPrime(2)
Debug IsPrime(83)
Debug IsPrime(97)
; IDE Options = PureBasic 5.42 Beta 1 LTS (Windows - x86)
; CursorPosition = 30
; Folding = -
; EnableUnicode
; EnableXP