﻿;==================================================================
; Rosetta Task: Prime decomposition
;
; The prime decomposition of a number is defined as a list of prime numbers which when all multiplied together, are equal to that number.
;
; Example: 12 = 2 × 2 × 3, so its prime decomposition is {2, 2, 3}
;==================================================================

;NOTE: Antivirus (Kaspersky) doesn't like it.

CompilerIf #PB_Compiler_Debugger
  CompilerError "Turn off the debugger if you want reasonable speed in this example."
CompilerEndIf
 
Define.q
 
Procedure Factor(Number, List Factors())
  Protected I = 3
  While Number % 2 = 0
    AddElement(Factors())
    Factors() = 2
    Number / 2
  Wend
  Protected Max = Number
  While I <= Max And Number > 1
    While Number % I = 0
      AddElement(Factors())
      Factors() = I
      Number/I
    Wend
    I + 2
  Wend
EndProcedure
 
Number = 9007199254740991
NewList Factors()
time = ElapsedMilliseconds()
Factor(Number, Factors())
time = ElapsedMilliseconds()-time
S.s = "Factored " + Str(Number) + " in " + StrD(time/1000, 2) + " seconds."
ForEach Factors()
  S + #CRLF$ + Str(Factors())
Next
MessageRequester("", S)
; Output:
; Factored 9007199254740991 in 0.27 seconds.
; 6361
; 69431
; 20394401
; IDE Options = PureBasic 5.41 LTS (Windows - x64)
; CursorPosition = 8
; Folding = -
; EnableUnicode
; EnableXP
; DisableDebugger