﻿;==================================================================
; Rosetta Task: Pythagorean triples
;
; The task is to determine how many Pythagorean triples there are with a perimeter no larger 
; than 100 and the number of these that are primitive.
;==================================================================

 
 
Procedure.i ConsoleWrite(t.s)  ; compile using /CONSOLE option
        OpenConsole()
        PrintN (t.s)
        CloseConsole()
        ProcedureReturn 1
EndProcedure
 
Procedure.i StdOut(t.s)  ; compile using /CONSOLE option
        OpenConsole()
        Print(t.s)
        CloseConsole()
        ProcedureReturn 1
EndProcedure
 
Procedure.i gcDiv(n,m) ; greatest common divisor
If n=0:ProcedureReturn m:EndIf
While m <> 0
  If n > m
    n - m
  Else
    m - n
  EndIf
Wend
ProcedureReturn n
EndProcedure
 
st=ElapsedMilliseconds()
 
nmax      =100; 00
power     =8
 
Dim primitiveA(power)
Dim alltripleA(power)
Dim pmaxA(power)
 
x=1
For i=1 To power
  x*10:pmaxA(i)=x/2
Next
 
For n=1 To nmax
  For m=(n+1) To (nmax+1) Step 2 ; assure m-n is odd
    d=gcDiv(n,m)
    p=m*m+m*n
    For i=1 To power
      If p<=pmaxA(i)
        If d =1
        primitiveA(i)+1        ; right here we have the primitive perimeter "seed" 'p'
        k=1:q=p*k              ; set k to one to include p : use q as the 'p*k'
          While q<=pmaxA(i)
          alltripleA(i)+1      ; accumulate multiples of this perimeter while q <= pmaxA(i)
          k+1:q=p*k
          Wend
        EndIf
      EndIf
    Next
  Next
Next
 
For i=1 To power
  t.s="Up to "+Str(pmaxA(i)*2)+": "
  t.s+Str(alltripleA(i))+" triples, "
  t.s+Str(primitiveA(i))+" primitives."
  ConsoleWrite(t.s)
Next
ConsoleWrite("")
et=ElapsedMilliseconds()-st:ConsoleWrite("Elapsed time = "+Str(et)+" milliseconds")

; IDE Options = PureBasic 5.42 Beta 1 LTS (Windows - x86)
; CursorPosition = 76
; FirstLine = 41
; Folding = -
; EnableUnicode
; EnableXP