﻿;==================================================================
; Rosetta Task: Queue - Definition
;
; Implement a FIFO queue. Elements are added at one side and popped from the other in the order of insertion.
;==================================================================

;For FIFO function PureBasic normally uses linked lists. Usage as described above could look like;

NewList MyStack()
 
Procedure Push(n)
  Shared MyStack()
  LastElement(MyStack())
  AddElement(MyStack())
  MyStack()=n
EndProcedure
 
Procedure Pop()
  Shared MyStack()
  Protected n
  If FirstElement(MyStack())  ; e.g. Stack not empty
    n=MyStack()
    DeleteElement(MyStack(),1)
  Else
    Debug "Pop(), out of range. Error at line "+Str(#PB_Compiler_Line)
  EndIf
  ProcedureReturn n
EndProcedure
 
Procedure Empty()
  Shared MyStack()
  If  ListSize(MyStack())=0
    ProcedureReturn #True
  EndIf
  ProcedureReturn #False
EndProcedure
 
;----   Example of implementation ----
Push(3)
Push(1)
Push(4)
While Not Empty()
  Debug Pop()
Wend
;----   Now an extra Pop(), e.g. one to many ----
Debug Pop()

; Output:
;  3
;  1
;  4
;  Pop(), out of range. Error at line 17
;  0
; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 6
; Folding = -
; EnableXP
; EnableUnicode