﻿;==================================================================
; Rosetta Task: Roman numerals - Decode
;
; Create a function that takes a Roman numeral as its argument and returns its value as a numeric decimal 
; integer. You don't need to validate the form of the Roman numeral.
;
; Modern Roman numerals are written by expressing each decimal digit of the number to be encoded 
; separately, starting with the leftmost digit and skipping any 0s. So 1990 is rendered "MCMXC" 
; (1000 = M, 900 = CM, 90 = XC) and 2008 is rendered "MMVIII" (2000 = MM, 8 = VIII). The Roman numeral
; for 1666, "MDCLXVI", uses each letter in descending order.
;==================================================================

Procedure romanDec(roman.s)
  Protected i, n, lastval, arabic
 
  For i = Len(roman) To 1 Step -1
    Select UCase(Mid(roman, i, 1))
      Case "M"
        n = 1000
      Case "D"
        n = 500
      Case "C"
        n = 100
      Case "L"
        n = 50
      Case "X"
        n = 10
      Case "V"
        n = 5
      Case "I"
        n = 1
      Default
        n = 0
    EndSelect
    If (n < lastval)
      arabic - n
    Else
      arabic + n
    EndIf
    lastval = n
  Next 
 
  ProcedureReturn arabic
EndProcedure
 
If OpenConsole()
  PrintN(Str(romanDec("MCMXCIX"))) ;1999
  PrintN(Str(romanDec("MDCLXVI"))) ;1666
  PrintN(Str(romanDec("XXV")))     ;25
  PrintN(Str(romanDec("CMLIV")))   ;954
  PrintN(Str(romanDec("MMXI")))    ;2011
 
  Print(#CRLF$ + #CRLF$ + "Press ENTER to exit"): Input()
  CloseConsole()
EndIf

; Output:
; 1999
; 1666
; 25
; 954
; 2011
; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 9
; Folding = -
; EnableXP
; EnableUnicode