﻿;==================================================================
; Rosetta Task: Roots of a function
;
; Create a program that finds and outputs the roots of a given function, range and (if applicable) step width. 
; The program should identify whether the root is exact or approximate.
;
; For this example, use f(x)=x3-3x2+2x.
;==================================================================

; from Translation of: C++

Procedure.d f(x.d)
  ProcedureReturn x*x*x-3*x*x+2*x
EndProcedure
 
Procedure main()
  OpenConsole()
  Define.d StepSize= 0.001
  Define.d Start=-1, stop=3
  Define.d value=f(start), x=start
  Define.i oldsign=Sign(value)
 
  If value=0
    PrintN("Root found at "+StrF(start))
  EndIf
 
  While x<=stop
    value=f(x)
    If Sign(value) <> oldsign
      PrintN("Root found near "+StrF(x))
    ElseIf value = 0
      PrintN("Root found at "+StrF(x))
    EndIf
    oldsign=Sign(value)
    x+StepSize
  Wend
Input()
EndProcedure
 
main()

; IDE Options = PureBasic 5.42 Beta 1 LTS (Windows - x86)
; CursorPosition = 10
; FirstLine = 3
; Folding = -
; EnableUnicode
; EnableXP