﻿;==================================================================
; Rosetta Task: Scope modifiers
;
; Most programming languages offer support for subroutines. When execution changes between subroutines,
; different sets of variables and functions ("scopes") are available to the program. Frequently these sets are 
; defined by the placement of the variable and function declarations ("static scoping" or "lexical scoping"). 
; These sets may also be defined by special modifiers to the variable and function declarations.

; Show the different scope modifiers available in your language and briefly explain how they change the scope
; of their variable or function. If your language has no scope modifiers, note it.
; ------------------------------

; Notes:
; - Functions must be defined before being used and are always global in scope.
; - Variables must be defined before being used. They do not have to be explicity defined, simply using them will 
;    define them. The keyword EnableExplicit may also be used to require explicit definitions before using a variable.
;
; - Two main divisions in scope exist. The first scope is the body of code outside of all procedures and the second is 
;    the scope within a single given procedure.
;
; If a variable is not explicitly defined its scope is local to one of the aforementioned areas. This may be modified
; by using one of the keywords: Global, Protected, or Shared. The effects are detailed by the comments in the sample code.
;==================================================================


;define a local integer variable by simply using it
baseAge.i = 10

;explicitly define local strings
Define person.s = "Amy", friend.s = "Susan"

;define variables that are both accessible inside and outside procedures
Global ageDiff = 3
Global extraYears = 5
 
 
Procedure test()
  ;define a local integer variable by simply using it
  baseAge.i = 30
  ;explicitly define a local string
  Define person.s = "Bob"
  ;allow access to a local variable in the main body of code
  Shared friend
  ;create a local variable distinct from a variable with global scope having the same name
  Protected extraYears = 2
 
  PrintN(person + " and " + friend + " are " + Str(baseAge) + " and " + Str(baseAge + ageDiff + extraYears) + " years old.")
EndProcedure
 
 
If OpenConsole()
  test()
 
  PrintN(person + " and " + friend + " are " + Str(baseAge) + " and " + Str(baseAge + ageDiff + extraYears) + " years old.")
 
  Print(#CRLF$ + #CRLF$ + "Press ENTER to exit")
  Input()
  CloseConsole()
EndIf
; Output:
; Bob And Susan are 30 And 35 years old.
; Amy And Susan are 10 And 18 years old.
; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 10
; FirstLine = 6
; Folding = -
; EnableXP
; EnableUnicode