﻿;==================================================================
; Rosetta Task: Sierpinski carpet
;
; Produce a graphical or ASCII-art representation of a Sierpinski carpet of order N.
;
; The use of # characters is not rigidly required for ASCII art. The important requirement is the placement
;  of whitespace and non-whitespace characters.
;==================================================================

; Translation of: Python
OpenConsole()

Procedure in_carpet(x,y)
  While x>0 And y>0
    If x%3=1 And y%3=1
      ProcedureReturn #False
    EndIf
    y/3: x/3
  Wend 
  ProcedureReturn #True
EndProcedure
 
Procedure carpet(n)
  Define i, j, l=Pow(3,n)-1
  For i=0 To l
    For j=0 To l
      If in_carpet(i,j)
        Print("#")
      Else
        Print(" ")
      EndIf
    Next
    PrintN("")
  Next
EndProcedure

;Sample...
n = 3
carpet(n)
Input()
; IDE Options = PureBasic 5.42 Beta 1 LTS (Windows - x86)
; CursorPosition = 37
; FirstLine = 4
; Folding = -
; EnableUnicode
; EnableXP