﻿;==================================================================
; Rosetta Task: Sieve of Eratosthenes
;
; The Sieve of Eratosthenes is a simple algorithm that finds the prime numbers up to a given integer. 
;==================================================================

; Basic Procedure
;      For n=2 To Sqr(lim)
;        If Nums(n)=0
;          m=n*n
;          While m<=lim
;            Nums(m)=1
;            m+n
;          Wend
;        EndIf
;      Next n

; Working example
Dim Nums.i(0)
Define l, n, m, lim
 
If OpenConsole()
 
  ; Ask for the limit to search, get that input and allocate a Array
  Print("Enter your limit for this search: ")
  lim=Val(Input())
  ReDim Nums(lim)
 
  ; Use a basic Sieve of Eratosthenes
  For n=2 To Sqr(lim)
    If Nums(n)=#False
      m=n*n
      While m<=lim
        Nums(m)=#True
        m+n
      Wend
    EndIf
  Next n
 
  ;Present the result to our user
  PrintN(#CRLF$+"The Primes up to "+Str(lim)+" are;")
  m=0: l=Log10(lim)+1
  For n=2 To lim
    If Nums(n)=#False
      Print(RSet(Str(n),l)+" ")
      m+1
      If m>72/(l+1)
        m=0: PrintN("")
      EndIf
    EndIf
  Next
 
  Print(#CRLF$+#CRLF$+"Press ENTER to exit"): Input()
  CloseConsole()
EndIf
; Output may look like;
; 
; Enter limit For this search: 750
; 
; The Primes up To 750 are;
;    2    3    5    7   11   13   17   19   23   29   31   37   41   43   47
;   53   59   61   67   71   73   79   83   89   97  101  103  107  109  113
;  127  131  137  139  149  151  157  163  167  173  179  181  191  193  197
;  199  211  223  227  229  233  239  241  251  257  263  269  271  277  281
;  283  293  307  311  313  317  331  337  347  349  353  359  367  373  379
;  383  389  397  401  409  419  421  431  433  439  443  449  457  461  463
;  467  479  487  491  499  503  509  521  523  541  547  557  563  569  571
;  577  587  593  599  601  607  613  617  619  631  641  643  647  653  659
;  661  673  677  683  691  701  709  719  727  733  739  743
; 
; Press ENTER To exit
; IDE Options = PureBasic 5.42 Beta 1 LTS (Windows - x86)
; CursorPosition = 59
; FirstLine = 32
; EnableUnicode
; EnableXP