﻿;==================================================================
; Rosetta Task: Singly-linked list - Element insertion
;
; Using the link element defined in Singly-Linked List (element), define a method to insert an element 
; into a singly-linked list following a given element.
; Using this method, insert an element C into a list comprised of elements A->B, following element A.
;==================================================================

; from Singly-linked list - Element Definition.pb
Structure MyData
  *next.MyData
  Value.i
EndStructure

Procedure insertAfter(Value, *node.MyData = #Null)
  Protected *newNode.MyData = AllocateMemory(SizeOf(MyData))
  If *newNode
    If *node
      *newNode\next = *node\next
      *node\next = *newNode
    EndIf 
    *newNode\Value = Value
  EndIf 
  ProcedureReturn *newNode ;return pointer to newnode
EndProcedure
 
 
Define *SL_List.MyData, a = 1, b = 2, c = 3
 
*SL_List = insertAfter(a) ;start the list
insertAfter(b, *SL_List) ;insert after head of list
insertAfter(c, *SL_List) ;insert after head of list and before tail

; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 5
; Folding = -
; EnableXP
; EnableUnicode