﻿;==================================================================
; Rosetta Task: Sort an array of composite structures
;
; Sort an array of composite structures by a key. For example, if you define a composite structure that
; presents a name-value pair (in pseudocode):
; 
; Define structure pair such that: 
;    name as a string
;    value as a string
;
; And an array of such pairs:
; 
; x: array of pairs
; then define a sort routine that sorts the array x by the key name.
;==================================================================

; PureBasic natively supports sorting of structured data with;
; 
; SortStructuredArray()
; SortStructuredList()
; The on-line documentation gives a more complete picture.


; Example................

Structure MyPair ; Define a structured data type
  Name$
  Value.i
EndStructure
 
Dim People.MyPair(2)             ; Allocate some elements
 
People(0)\Name$ = "John"         ; Start filling them in
People(0)\Value = 100
 
People(1)\Name$ = "Emma"
People(1)\Value = 200
 
People(2)\Name$ = "Johnny"
People(2)\Value = 175
 
If OpenConsole()
  Define i
  ; Sort ascending by name
  SortStructuredArray(People(), #PB_Sort_Ascending, OffsetOf(MyPair\Name$), #PB_String)
  PrintN(#CRLF$+"Sorted ascending by name.")
  For i=0 To 2
    PrintN(People(i)\Name$+" - Value: "+Str(People(i)\Value))
  Next
  ; Sort descending by value
  SortStructuredArray(People(), #PB_Sort_Descending, OffsetOf(MyPair\Value), #PB_Integer)
  PrintN(#CRLF$+"Sorted descending by value.")
  For i=0 To 2
    PrintN(People(i)\Name$+" - Value: "+Str(People(i)\Value))
  Next
  ; Wait for user...
  PrintN(#CRLF$+"Press ENTER to exit"):Input()
EndIf

; Outputs
; 
; Sorted ascending by name.
; Emma - Value: 200
; John - Value: 100
; Johnny - Value: 175
; 
; Sorted descending by value.
; Emma - Value: 200
; Johnny - Value: 175
; John - Value: 100
; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 20
; FirstLine = 18
; Markers = 60
; EnableXP
; EnableUnicode