﻿;==================================================================
; Rosetta Task: Sort disjoint sublist
;
; Given a list of values and a set of integer indices into that value list, the task is to sort the values at 
; the given indices, but preserving the values at indices outside the set of those to be sorted.
;==================================================================

; Based on the C implementation

Procedure Bubble_sort(Array idx(1), n, Array buf(1))
  Protected i, j
  SortArray(idx(),#PB_Sort_Ascending)
  For i=0 To n
    For j=i+1 To n
      If buf(idx(j)) < buf(idx(i))
        Swap buf(idx(j)), buf(idx(i))
      EndIf
    Next
  Next 
EndProcedure
 
Procedure main()
  DataSection
       values: 
       Data.i 7, 6, 5, 4, 3, 2, 1, 0
       indices:
       Data.i 6, 1, 7
  EndDataSection
 
  Dim values.i(7) :CopyMemory(?values, @values(), SizeOf(Integer)*8)
  Dim indices.i(2):CopyMemory(?indices,@indices(),SizeOf(Integer)*3)
 
  If OpenConsole()
    Protected i
    PrintN("Before sort:")
    For i=0 To ArraySize(values())
      Print(Str(values(i))+" ")
    Next
 
    PrintN(#CRLF$+#CRLF$+"After sort:")
    Bubble_sort(indices(), ArraySize(indices()), values())
    For i=0 To ArraySize(values())
      Print(Str(values(i))+" ")
    Next
 
    Print(#CRLF$+#CRLF$+"Press ENTER to exit")
    Input()
  EndIf 
EndProcedure
 
main()
; Before sort:
; 7 6 5 4 3 2 1 0
; 
; After sort:
; 7 0 5 4 3 2 1 6

; IDE Options = PureBasic 5.42 Beta 1 LTS (Windows - x86)
; CursorPosition = 26
; FirstLine = 19
; Folding = -
; EnableUnicode
; EnableXP