﻿;==================================================================
; Rosetta Task: Sorting algorithms - Cocktail sort
;
; The cocktail shaker sort is an improvement on the Bubble Sort. The improvement is basically that values 
; "bubble" both directions through the array, because on each iteration the cocktail shaker sort bubble sorts
;  once forwards and once backwards. 
;==================================================================


; Pseudocode for the algorithm..

; The following approach improves on the method in the pseudo-code by not examining indexes on either 
; end of the array that have already been sorted by reducing the index range on each subsequent pass.

;sorts an array of integers
Procedure cocktailSort(Array a(1))
  Protected index, hasChanged, low, high
 
  low = 0
  high = ArraySize(a()) - 1
  Repeat
    hasChanged = #False
    For index = low To high
      If a(index) > a(index + 1)
        Swap a(index), a(index + 1) 
        hasChanged = #True
      EndIf 
    Next 
    high - 1
 
    If hasChanged = #False
      Break ;we can exit the outer loop here if no changes were made
    EndIf 
 
 
    hasChanged = #False
    For index = high To low Step -1
      If a(index) > a(index + 1)
        Swap a(index), a(index + 1)
        hasChanged = #True
      EndIf
    Next
    low + 1
  Until hasChanged = #False ;if no elements have been changed, then the array is sorted
EndProcedure

; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 12
; Folding = -
; EnableXP
; EnableUnicode