﻿;==================================================================
; Rosetta Task: Sorting algorithms - Heapsort
;
; Heapsort is an in-place sorting algorithm with worst case and average complexity of O(nLOGn).
;
; The basic idea is to turn the array into a binary heap structure, which has the property that it allows 
; efficient retrieval and removal of the maximal element. We repeatedly "remove" the maximal element
; from the heap, thus building the sorted list from back to front. Heapsort requires random access, so 
; can only be used on an array-like data structure.
;==================================================================

Declare heapify(Array a(1), count)
Declare siftDown(Array a(1), start, ending)
 
Procedure heapSort(Array a(1), count)
  Protected ending=count-1
  heapify(a(), count)
  While ending>0
    Swap a(ending),a(0)
    siftDown(a(), 0, ending-1)
    ending-1
  Wend
EndProcedure
 
Procedure heapify(Array a(1), count)
  Protected start=(count-2)/2
  While start>=0
    siftDown(a(),start,count-1)
    start-1
  Wend  
EndProcedure
 
Procedure siftDown(Array a(1), start, ending)
  Protected root=start, child
  While (root*2+1)<=ending
    child=root*2+1
    If child+1<=ending And a(child)<a(child+1)
      child+1
    EndIf
    If a(root)<a(child)
      Swap a(root), a(child)
      root=child
    Else
      Break  
    EndIf
  Wend
EndProcedure
; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 10
; Folding = -
; EnableXP
; EnableUnicode