﻿;==================================================================
; Rosetta Task: Sorting algorithms - Insertion sort
;
; An O(n2) sorting algorithm which moves elements one at a time into the correct position. The algorithm 
; consists of inserting one element at a time into the previously sorted part of the array, moving higher 
; ranked elements up as necessary. To start off, the first (or smallest, or any arbitrary) element of the 
; unsorted array is considered to be the sorted part.
;==================================================================

Procedure insertionSort(Array a(1))
  Protected low, high
  Protected firstIndex, lastIndex = ArraySize(a())
 
  If lastIndex > firstIndex + 1
    low = firstIndex + 1
    While low <= lastIndex
      high = low
      While high > firstIndex
        If a(high) < a(high - 1)
          Swap a(high), a(high - 1)
        Else
          Break
        EndIf
        high - 1
      Wend
      low + 1
    Wend
  EndIf
EndProcedure
; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 6
; Folding = -
; EnableXP
; EnableUnicode