﻿;==================================================================
; Rosetta Task: Sorting algorithms - Merge sort
;
; The merge sort is a recursive sort of order n*log(n).

; It is notable For having a worst case  and average complexity of O(n*Log(n)), and a best case complexity 
; of O(n) (For pre-sorted input). The basic idea is to split the collection into smaller groups by halving it 
; until the groups only have one element or no elements (which are both entirely sorted groups). Then 
; merge the groups back together so that their elements are in order. This is how the algorithm gets 
; its "divide and conquer" description.
;==================================================================

; A non-optimized version with lists.

Procedure display(List m())
  ForEach m()
    Print(LSet(Str(m()), 3," "))
  Next
  PrintN("")
EndProcedure
 
;overwrites list m() with the merger of lists ma() and mb()
Procedure merge(List m(), List ma(), List mb())
  FirstElement(m())
  Protected ma_elementExists = FirstElement(ma())
  Protected mb_elementExists = FirstElement(mb()) 
  Repeat
    If ma() <= mb()
      m() = ma(): NextElement(m())
      ma_elementExists = NextElement(ma())
    Else
      m() = mb(): NextElement(m())
      mb_elementExists = NextElement(mb())
    EndIf
  Until Not (ma_elementExists And mb_elementExists)
 
  If ma_elementExists
    Repeat
      m() = ma(): NextElement(m())
    Until Not NextElement(ma())
  ElseIf mb_elementExists
    Repeat
      m() = mb(): NextElement(m())
    Until Not NextElement(mb())
  EndIf
EndProcedure
 
Procedure mergesort(List m())
  Protected NewList ma()
  Protected NewList mb()
 
  If ListSize(m()) > 1
    Protected current, middle = (ListSize(m()) / 2 ) - 1
 
    FirstElement(m())
    While current <= middle
      AddElement(ma())
      ma() = m()
      NextElement(m()): current + 1
    Wend
 
    PreviousElement(m())
    While NextElement(m())
      AddElement(mb())
      mb() = m()
    Wend
 
    mergesort(ma())
    mergesort(mb())
    LastElement(ma()): FirstElement(mb())
    If ma() <= mb() 
      FirstElement(m())
      FirstElement(ma())
      Repeat
        m() = ma(): NextElement(m())
      Until Not NextElement(ma())
      Repeat
        m() = mb(): NextElement(m())
      Until Not NextElement(mb())
    Else 
      merge(m(), ma(), mb())
    EndIf 
  EndIf 
EndProcedure
 
If OpenConsole()
  Define i
  NewList x()
 
  For i = 1 To 21: AddElement(x()): x() = Random(60): Next
  display(x())
  mergesort(x())
  display(x())
 
  Print(#CRLF$ + #CRLF$ + "Press ENTER to exit")
  Input()
  CloseConsole()
EndIf
; Sample output:
; 22 51 31 59 58 45 11 2  16 56 38 42 2  10 23 41 42 25 45 28 42
; 2  2  10 11 16 22 23 25 28 31 38 41 42 42 42 45 45 51 56 58 59

; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 12
; Folding = -
; EnableXP
; EnableUnicode