﻿;==================================================================
; Rosetta Task: Sorting algorithms - Pancake sort
;
; Sort an array of integers (of any convenient size) into ascending order using Pancake sorting. In short, 
; instead of individual elements being sorted, the only operation allowed is to "flip" one end of the list, like so:
; 
; Before:
; 6 7 8 9 2 5 3 4 1
; After:
; 9 8 7 6 2 5 3 4 1
;
; Only one end of the list can be flipped; this should be the low end, but the high end is okay if it's 
; easier to code or works better, but it must be the same end for the entire solution. 
; (The end flipped can't be arbitrarily changed.)
;==================================================================

If OpenConsole()
  Define i, j, k, Loops
  Dim Pile(9)
  ;--------------------------------------------------------------
  ;- Create a Random Pile()
  For i=1 To 9                             ;- Initiate the Pile
    Pile(i)=i
  Next
  For i=9 To 1 Step -1                     ;- Do a Fisher-Yates shuffle
    Swap Pile(i),Pile(Random(i-1)+1)
  Next
  Print("Random Pile()    :")
  For i=1 To 9
    Print(" "+Str(Pile(i)))
  Next
  ;--------------------------------------------------------------
  ;- Start Sorting
  For i=9 To 2 Step -1
    If Pile(i)<>i       ;- Only Flip it if the current cake need Swapping
      Loops+1
      j=0
      Repeat            ;- find place of Pancake(i) in the Pile()
        j+1
      Until Pile(j)=i 
 
      For k=1 To (j/2)  ;- Flip it up
        Swap Pile(k),Pile(j-k+1)
      Next              
      For k=1 To i/2    ;- Flip in place
        Swap Pile(k),Pile(i-k+1)
      Next
 
    EndIf
  Next
 
  Print(#CRLF$+"Resulting Pile() :")
  For i=1 To 9
    Print(" "+Str(Pile(i)))
  Next
  Print(#CRLF$+"All done in "+Str(Loops)+" loops.")
  Print(#CRLF$+#CRLF$+"Press ENTER to quit."): Input()
  CloseConsole()
EndIf
; Output can look like
; 
; Original Pile()  : 9 4 1 8 6 3 2 5 7
; Resulting Pile() : 1 2 3 4 5 6 7 8 9
; All done in 6 loops.
; 
; Press ENTER To quit.
; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 11
; EnableXP
; EnableUnicode