﻿;==================================================================
; Rosetta Task: Sorting algorithms - Selection sort
;
; In this task, the goal is to sort an array (or list) of elements using the Selection sort algorithm. 
; It works as follows:
; First find the smallest element in the array and exchange it with the element in the first position, then
; find the second smallest element and exchange it with the element in the second position, and continue
; in this way until the entire array is sorted. Its asymptotic complexity is O(n2) making it inefficient on large
; arrays. Its primary purpose is for when writing data is very expensive (slow) when compared to reading, 
; eg. writing to flash memory or EEPROM. 
; NOTE: No other sorting algorithm has less data movement.
;==================================================================

Procedure selectionSort(Array a(1))
  Protected i, j, lastIndex, minIndex
 
  lastIndex = ArraySize(a())
  For i = 0 To lastIndex - 1
    minIndex = i
    For j = i + 1 To lastIndex
      If a(minIndex) > a(j)
        minIndex = j
      EndIf
    Next
    Swap a(minIndex), a(i)
  Next  
EndProcedure
; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 10
; Folding = -
; EnableXP
; EnableUnicode