﻿;==================================================================
; Rosetta Task: Sorting algorithms - Shell sort
;
; In this task, the goal is to sort an array of elements using the Shell sort algorithm, a diminishing 
; increment sort. The Shell sort is named after its inventor, Donald Shell, who published the algorithm 
; in 1959. Shellsort is a sequence of interleaved insertion sorts based on an increment sequence. 
;==================================================================

; Translation of: Fortran

#STEP=2.2
 
Procedure Shell_sort(Array A(1))
  Protected l=ArraySize(A()), increment=Int(l/#STEP)
  Protected i, j, temp
  While increment
    For i= increment To l
      j=i
      temp=A(i)
      While j>=increment And A(j-increment)>temp
        A(j)=A(j-increment)
        j-increment
      Wend
      A(j)=temp
    Next i
    If increment=2
      increment=1
    Else
      increment*(5.0/11)
    EndIf
  Wend
EndProcedure
; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 3
; Folding = -
; EnableXP
; EnableUnicode