﻿;==================================================================
; Rosetta Task: Sorting algorithms - Stooge sort
;
; Show the Stooge Sort for an array of integers.
; 
; The Stooge Sort algorithm is as follows:
; 
; algorithm stoogesort(Array L, i = 0, j = length(L)-1)
;      If L[j] < L[i] then
;          L[i] ↔ L[j]
;      If j - i > 1 then
;          t := (j - i + 1)/3
;          stoogesort(L, i  , j-t)
;          stoogesort(L, i+t, j  )
;          stoogesort(L, i  , j-t)
;      Return L
;==================================================================

Procedure Stooge_Sort(Array L.i(1), i=0 , j=0)
  If j=0
    j=ArraySize(L())
  EndIf
  If L(i)>L(j)
    Swap L(i), L(j)
  EndIf
  If j-i>1
    Protected t=(j-i+1)/3
    Stooge_Sort(L(), i,   j-t)
    Stooge_Sort(L(), i+t, j )
    Stooge_Sort(L(), i,   j-t)
  EndIf
EndProcedure

; Implementation may be as...

Define AmountOfPosts=(?Stop_Data-?Start_data)/SizeOf(Integer)
Dim    Xyz.i(AmountOfPosts)
CopyMemory(?Start_data, @Xyz(), ?Stop_Data-?Start_data)
 
Stooge_Sort(Xyz())
 
For i=0 To ArraySize(Xyz())
  Debug Xyz(i)
Next i
 
DataSection
  Start_data:
  Data.i  1, 4, 5, 3, -6, 3, 7, 10, -2, -5, 7, 5, 9, -3, 7
  Stop_Data:
EndDataSection
; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 33
; Folding = -
; EnableXP
; EnableUnicode