﻿;==================================================================
; Rosetta Task: Spiral matrix
;
; Produce a spiral array. 
; A spiral Array is a square arrangement of the first N2 natural numbers, where the numbers increase 
; sequentially as you go around the edges of the array spiralling inwards.
;==================================================================

; Translation of: Fortran

Procedure spiralMatrix(size = 1)
  Protected i, x = -1, y, count = size, n
  Dim a(size - 1,size - 1)
 
  For i = 1 To count
    x + 1
    a(x,y) = n
    n + 1
  Next
 
  Repeat
    count - 1
    For i = 1 To count
      y + 1
      a(x,y) = n
      n + 1
    Next
    For i = 1 To count
      x - 1
      a(x,y) = n
      n + 1
    Next
 
    count - 1
    For i = 1 To count
      y - 1
      a(x,y) = n
      n + 1
    Next
    For i = 1 To count
      x + 1
      a(x,y) = n
      n + 1
    Next
  Until count < 1
 
  PrintN("Spiral: " + Str(Size) + #CRLF$)
  Protected colWidth = Len(Str(size * size - 1)) + 1
  For y = 0 To size - 1
    For x = 0 To size - 1
      Print("" + LSet(Str(a(x, y)), colWidth, " ") + "")
    Next
    PrintN("")
  Next
  PrintN("")
EndProcedure
 
If OpenConsole()
  spiralMatrix(2)
  PrintN("")
  spiralMatrix(5)
 
 
  Print(#CRLF$ + #CRLF$ + "Press ENTER to exit")
  Input()
  CloseConsole()
EndIf
; Output:
; Spiral: 2
; 
; 0 1
; 3 2
; 
; 
; Spiral: 5
; 
; 0  1  2  3  4
; 15 16 17 18 5
; 14 23 24 19 6
; 13 22 21 20 7
; 12 11 10 9  8
; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 5
; Folding = -
; EnableXP
; EnableUnicode