﻿;==================================================================
; Rosetta Task: Stair-climbing puzzle
;
; Your stair-climbing robot has a very simple low-level API: the "step" function takes no argument and 
; attempts to climb one step as a side effect. Unfortunately, sometimes the attempt fails and the robot 
; clumsily falls one step instead. The "step" function detects what happens and returns a boolean flag: 
; true on success, false on failure. Write a function "step_up" that climbs one step up 
; [from the initial position] (by repeating "step" attempts if necessary). Assume that the robot is not 
; already at the top of the stairs, and neither does it ever reach the bottom of the stairs. How small 
; can you make "step_up"? Can you avoid using variables (even immutable ones) and numbers?
;==================================================================

; Iterative version using one variable.
;           
;           Procedure step_up()
;             Protected i
;             Repeat: If _step(): i + 1: Else: i - 1: EndIf: Until i = 1
;           EndProcedure

; Recursive version. Stack may overflow as probability of a fall approaches or exceeds 50%.

;           Procedure step_up()
;             While Not _step()
;               step_up()
;             Wend 
;           EndProcedure

;==================================================================
;- Demonstration program.
;==================================================================

Global level
 
Procedure _step()
  If Random(1) ;equal chance of stepping up or falling down
    level + 1
    PrintN("Climbed up to " + Str(level))
    ProcedureReturn #True
  Else
    level - 1
    PrintN("Fell down to " + Str(level))
    ProcedureReturn #False
  EndIf 
EndProcedure
 
;recursive
Procedure step_up()
  While Not _step()
    step_up()
  Wend 
EndProcedure
 
If OpenConsole()
  PrintN("Begin at level: " + Str(level))
  step_up()
  PrintN("*** Now at level: " + Str(level))
 
  Print(#CRLF$ + #CRLF$ + "Press ENTER to exit")
  Input()
  CloseConsole()
EndIf
; Sample output:
; 
; Begin at level: 0
; Fell down To -1
; Climbed up To 0
; Fell down To -1
; Climbed up To 0
; Climbed up To 1
; *** Now at level: 1
; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 19
; Folding = -
; EnableXP
; EnableUnicode