﻿;==================================================================
; Rosetta Task: Standard deviation
;
; Write a stateful function, class, generator or coroutine that takes a series of floating point numbers, 
; one at a time, and returns the running standard deviation of the series. The task implementation 
; should use the most natural programming style of those listed for the function in the implementation 
; language; the task must state which is being used. Do not apply Bessel's correction; the returned 
; standard deviation should always be computed as if the sample seen so far is the entire population.
;==================================================================

;Define our Standard deviation function
Declare.d Standard_deviation(x)
 
; Main program
If OpenConsole()
  Define i, x
  Restore MyList
  For i=1 To 8
    Read.i x
    PrintN(StrD(Standard_deviation(x)))
  Next i
  Print(#CRLF$+"Press ENTER to exit"): Input()
EndIf
 
;Calculation procedure, with memory
Procedure.d Standard_deviation(In)
  Static in_summa, antal
  Static in_kvadrater.q
  in_summa+in
  in_kvadrater+in*in
  antal+1
  ProcedureReturn Pow((in_kvadrater/antal)-Pow(in_summa/antal,2),0.50)
EndProcedure
 
;data section
DataSection
MyList:
  Data.i  2,4,4,4,5,5,7,9
EndDataSection

; Output:
;  0.0000000000
;  1.0000000000
;  0.9428090416
;  0.8660254038
;  0.9797958971
;  1.0000000000
;  1.3997084244
;  2.0000000000
; IDE Options = PureBasic 5.42 Beta 1 LTS (Windows - x86)
; CursorPosition = 39
; Folding = -
; EnableUnicode
; EnableXP