﻿;==================================================================
; Rosetta Task: String length
;
; In this task, the goal is to find the character and byte length of a string. This means encodings like
; UTF-8 need to be handled properly, as there is not necessarily a one-to-one relationship between bytes
; and characters. 
;==================================================================

; Character Length..............
a = Len("Hello World") ;a will be 11
Debug a
Debug "----------------"


; Byte Length............
; Returns the number of bytes required to store the string in memory in the given format in bytes. 'Format' 
; can be #PB_Ascii, #PB_UTF8 Or #PB_Unicode. PureBasic code can be compiled using either Unicode (2-byte) 
; or Ascii (1-byte) encodings for strings. If 'Format' is not specified, the mode of the executable (unicode or ascii) is used.

; Note: The number of bytes returned does not include the terminating Null-Character of the string. The size of
; the Null-Character is 1 byte For Ascii and UTF8 mode and 2 bytes for Unicode mode.

a = StringByteLength("ä", #PB_UTF8)    ;a will be 2
b = StringByteLength("ä", #PB_Ascii)   ;b will be 1
c = StringByteLength("ä", #PB_Unicode) ;c will be 2

Debug a
Debug b
Debug c
Debug "----------------"
; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 20
; EnableXP
; EnableUnicode