﻿;==================================================================
; Rosetta Task: String matching
;
; Given two strings, demonstrate the following 3 types of matchings:
; 
; - Determining if the first string starts with second string
; - Determining if the first string contains the second string at any location
; - Determining if the first string ends with the second string
;
; Optional requirements:
; - Print the location of the match for part 2
; - Handle multiple occurrences of a string for part 2.
;==================================================================

Procedure StartsWith1(String1$, String2$)
  Protected Result
  If FindString(String1$, String2$, 1) =1 ; E.g Found in possition 1
    Result =CountString(String1$, String2$)
  EndIf
  ProcedureReturn Result
EndProcedure
 
Procedure EndsWith1(String1$, String2$)
  Protected Result, dl=Len(String1$)-Len(String2$)
  If dl>=0 And Right(String1$, Len(String2$))=String2$
    Result =CountString(String1$, String2$)
  EndIf
  ProcedureReturn Result
EndProcedure

;And a verification
If OpenConsole()
  PrintN(Str(StartsWith1("Rosettacode", "Rosetta")))           ; = 1
  PrintN(Str(StartsWith1("Rosettacode", "code")))              ; = 0
  PrintN(Str(StartsWith1("eleutherodactylus cruralis", "e")))  ; = 3
  PrintN(Str(EndsWith1  ("Rosettacode", "Rosetta")))  ; = 0
  PrintN(Str(EndsWith1  ("Rosettacode", "code")))     ; = 1
  PrintN(Str(EndsWith1  ("Rosettacode", "e")))        ; = 2
 
  Print(#CRLF$ + #CRLF$ + "Press ENTER to exit"): Input()
  CloseConsole()
EndIf

;==================================================================
;--- An alternate And more complete solution:
;==================================================================

Procedure startsWith(string1$, string2$)
  ;returns one if string1$ starts with string2$, otherwise returns zero
  If FindString(string1$, string2$, 1) = 1
    ProcedureReturn 1
  EndIf 
  ProcedureReturn 0
EndProcedure
 
Procedure contains(string1$, string2$, location = 0)
  ;returns the location of the next occurrence of string2$ in string1$ starting from location,
  ;or zero if no remaining occurrences of string2$ are found in string1$
  ProcedureReturn FindString(string1$, string2$, location + 1)
EndProcedure
 
Procedure endsWith(string1$, string2$)
  ;returns one if string1$ ends with string2$, otherwise returns zero
  Protected ls = Len(string2$)
  If Len(string1$) - ls >= 0 And Right(string1$, ls) = string2$
    ProcedureReturn 1
  EndIf
  ProcedureReturn 0
EndProcedure
 
If OpenConsole()
  PrintN(Str(startsWith("RosettaCode", "Rosetta")))           ; = 1, true
  PrintN(Str(startsWith("RosettaCode", "Code")))              ; = 0, false
 
  PrintN("")
  PrintN(Str(contains("RosettaCode", "luck")))                ; = 0, no occurrences
  Define location
  Repeat
    location = contains("eleutherodactylus cruralis", "e", location)
    PrintN(Str(location))                                     ;display each occurrence: 1, 3, 7,  & 0 (no more occurrences)
  Until location = 0
 
  PrintN("")
  PrintN(Str(endsWith  ("RosettaCode", "Rosetta")))            ; = 0, false
  PrintN(Str(endsWith  ("RosettaCode", "Code")))               ; = 1, true
 
  Print(#CRLF$ + #CRLF$ + "Press ENTER to exit"): Input()
  CloseConsole()
EndIf
; Output:
; 1
; 0
; 
; 0
; 1
; 3
; 7
; 0
; 
; 0
; 1
; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 11
; Folding = -
; EnableXP
; EnableUnicode