﻿;==================================================================
; Rosetta Task: Strip a set of characters from a string
;
; The task is to create a function that strips a set of characters from a string. The function should take 
; two arguments: the first argument being a string to stripped and the second, a string containing 
; the set of characters to be stripped. The returned string should contain the first string, stripped of 
; any characters in the second argument:

; e.g. function StripChars("She was a soul stripper. She took my heart!","aei")
;                  Result$ = "Sh ws  soul strppr. Sh took my hrt!"
;==================================================================

; PureBasic uses a single-byte (For ASCII) or a two-byte NULL (For Unicode) to signal the end of a string. 
; Nulls are thus excluded from the allowable characters to strip as they can't be included in a PureBasic string.

Procedure.s stripChars(source.s,  charsToStrip.s)
  Protected i, *ptrChar.Character, length = Len(source), result.s
  *ptrChar = @source
  For i = 1 To length
    If Not FindString(charsToStrip, Chr(*ptrChar\c))
      result + Chr(*ptrChar\c)
    EndIf
    *ptrChar + SizeOf(Character)
  Next
  ProcedureReturn result 
EndProcedure
 
If OpenConsole()
  PrintN(stripChars("She was a soul stripper. She took my heart!", "aei"))
 
  Print(#CRLF$ + #CRLF$ + "Press ENTER to exit"): Input()
  CloseConsole()
EndIf

; Output:
; Sh ws  soul strppr. Sh took my hrt!
; IDE Options = PureBasic 5.42 Beta 1 LTS (Windows - x86)
; CursorPosition = 33
; Folding = -
; EnableUnicode
; EnableXP