﻿;==================================================================
; Rosetta Task: Strip comments from a string
;
; The task is to remove text that follow any of a set of comment markers, (in these examples either a 
; hash or a semicolon) from a string or input line.
;==================================================================

Procedure.s Strip_comments(Str$)
  Protected result$=Str$, l, l1, l2
  l1 =FindString(Str$,"#",1)
  l2 =FindString(Str$,";",1)
  ;
  ; See if any comment sign was found, prioritizing '#'
  If l1
    l=l1
  ElseIf l2
    l=l2
  EndIf
  l-1
  If l>0
    result$=Left(Str$,l)
  EndIf 
  ProcedureReturn result$
EndProcedure

;Implementation...
OpenConsole()
#instring1 ="apples, pears # and bananas"
#instring2 ="apples, pears ; and bananas"
 
PrintN(Strip_comments(#instring1))
PrintN(Strip_comments(#instring2))
Print(#CRLF$ + #CRLF$ + "Press ENTER to exit"): Input()
CloseConsole()
; Output:
; apples, pears
; apples, pears
; IDE Options = PureBasic 5.42 Beta 1 LTS (Windows - x86)
; CursorPosition = 33
; FirstLine = 1
; Folding = -
; EnableUnicode
; EnableXP