﻿;==================================================================
; Rosetta Task: Substring
;
; In this task display a substring:
; 
;      starting from n characters in and of m length;
;      starting from n characters in, up to the end of the string;
;      whole string minus last character;
;      starting from a known character within the string and of m length;
;      starting from a known substring within the string and of m length.
;
; If the program uses UTF-8 Or UTF-16, it must work on any valid Unicode code point, whether in the 
; Basic Multilingual Plane or above it. The program must reference logical characters (code points), not 
; 8-bit code units for UTF-8 or 16-bit code units for UTF-16. Programs for other encodings (such as 8-bit 
; ASCII, or EUC-JP) are not required to handle all Unicode characters.
;==================================================================

If OpenConsole()
 
  Define baseString.s, m, n
 
  baseString = "Thequickbrownfoxjumpsoverthelazydog."
  n = 12
  m = 5
 
  ;Display the substring starting from n characters in and of m length.
  PrintN(Mid(baseString, n, m))
 
  ;Display the substring starting from n characters in, up to the end of the string.
  PrintN(Mid(baseString, n)) ;or PrintN(Right(baseString, Len(baseString) - n))
 
  ;Display the substring whole string minus last character
  PrintN(Left(baseString, Len(baseString) - 1))
 
  ;Display the substring starting from a known character within the string and of m length.
  PrintN(Mid(baseString, FindString(baseString, "b", 1), m))
 
  ;Display the substring starting from a known substring within the string and of m length.
  PrintN(Mid(baseString, FindString(baseString, "ju", 1), m))
 
  Print(#CRLF$ + #CRLF$ + "Press ENTER to exit")
  Input()
  CloseConsole()
EndIf

; Output:
; wnfox
; wnfoxjumpsoverthelazydog.
; Thequickbrownfoxjumpsoverthelazydog
; brown
; jumps
; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 14
; EnableXP
; EnableUnicode