﻿;==================================================================
; Rosetta Task: Table creation - Postal addresses
;
; In this task, the goal is to create a table to store addresses. You may assume that all the addresses to 
; be stored will be located in the USA. As such, you will need (in addition to a field holding a unique identifier) 
; a field holding the street address, a field holding the city, a field holding the state code, and a field holding 
; the zipcode. Choose appropriate types for each field.

; For non-database languages, show how you would open a connection to a database (your choice of which) 
; and create an address table in it. You should follow the existing models here for how you would structure the table.
;==================================================================

; Easiest approach with sqlite. Further possible: PostgresQL or each other over ODBC.

 
UseSQLiteDatabase()
Procedure CheckDatabaseUpdate(Database, Query$)
   Result = DatabaseUpdate(Database, Query$)
   If Result = 0
      Print(DatabaseError())
   EndIf
   ProcedureReturn Result
EndProcedure
OpenConsole()
DatabaseFile$ = GetCurrentDirectory()+"/rosettadb.sdb"
If CreateFile(0, DatabaseFile$)
   CloseFile(0)
    If OpenDatabase(0, DatabaseFile$, "", "")
      CheckDatabaseUpdate(0,"CREATE TABLE address ( addrID INTEGER PRIMARY KEY AUTOINCREMENT,	addrStreet TEXT Not NULL, addrCity TEXT Not NULL, addrState TEXT Not NULL, addrZIP TEXT Not NULL)")
      CloseDatabase(0)
   Else
      Print("Can't open database !")
   EndIf
Else
   Print("Can't create the database file !")
EndIf
Input()
CloseConsole()
; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 9
; Folding = -
; EnableXP
; EnableUnicode