﻿;==================================================================
; Rosetta Task: Take notes on the command line
;
; Invoking NOTES without commandline arguments displays the current contents of the local NOTES.TXT 
; if it exists. If NOTES has arguments, the current date and time are appended to the local NOTES.TXT 
; followed by a newline. Then all the arguments, joined with spaces, prepended with a tab, and appended  
; With a trailing newline, are written To NOTES.TXT. If NOTES.TXT doesn't already exist in the current 
; directory then a new NOTES.TXT file should be created.
;==================================================================

#FileName="notes.txt"
Define argc=CountProgramParameters()
If OpenConsole()
  If argc=0
    If ReadFile(0,#FileName)
      While Eof(0)=0
        PrintN(ReadString(0))                    ; No new notes, so present the old
      Wend
      CloseFile(0)
    EndIf
  Else ; e.g. we have some arguments
    Define d$=FormatDate("%yyyy-%mm-%dd %hh:%ii:%ss",Date())
    If OpenFile(0,#FileName)
      Define args$=""
      While argc
        args$+" "+ProgramParameter()             ; Read all arguments
        argc-1
      Wend
      FileSeek(0,Lof(0))                         ; Go to the end of this file
      WriteStringN(0,d$+#CRLF$+#TAB$+args$)      ; Append date & note
      CloseFile(0)
    EndIf
  EndIf
EndIf
; IDE Options = PureBasic 5.42 Beta 1 LTS (Windows - x86)
; CursorPosition = 33
; EnableUnicode
; EnableXP