﻿;==================================================================
; Rosetta Task: Temperature conversion
;
; here are quite a number of temperature scales. 
; For this task we will concentrate on 4 of the perhaps best-known ones: Kelvin, Celsius, Fahrenheit and Rankine.
; 
; The Celsius and Kelvin scales have the same magnitude, but different null points.
; 
; 0 degrees Celsius corresponds to 273.15 kelvin.
; 0 kelvin is absolute zero.
; The Fahrenheit and Rankine scales also have the same magnitude, but different null points.
; 
; 0 degrees Fahrenheit corresponds to 459.67 degrees Rankine.
; 0 degrees Rankine is absolute zero.
; The Celsius/Kelvin and Fahrenheit/Rankine scales have a ratio of 5 : 9.
; 
; Write code that accepts a value of kelvin, converts it to values on the three other scales and prints the result.
;==================================================================

Procedure.d Kelvin2Celsius(tK.d)    : ProcedureReturn tK-273.15     : EndProcedure
Procedure.d Kelvin2Fahrenheit(tK.d) : ProcedureReturn tK*1.8-459.67 : EndProcedure
Procedure.d Kelvin2Rankine(tK.d)    : ProcedureReturn tK*1.8        : EndProcedure
 
OpenConsole()
Repeat
  Print("Temperatur Kelvin? ") : Kelvin.d = ValD(Input())
  PrintN("Conversion:")
  PrintN(#TAB$+"Celsius   "+#TAB$+RSet(StrD(Kelvin2Celsius(Kelvin),2),8,Chr(32)))
  PrintN(#TAB$+"Fahrenheit"+#TAB$+RSet(StrD(Kelvin2Fahrenheit(Kelvin),2),8,Chr(32)))
  PrintN(#TAB$+"Rankine   "+#TAB$+RSet(StrD(Kelvin2Rankine(Kelvin),2),8,Chr(32)))
  PrintN("ESC = End.")
  Repeat 
    k$=Inkey() : Delay(50) : If RawKey()=#ESC : End : EndIf
  Until RawKey()  
ForEver
; Temperatur Kelvin? 21
; Conversion:
;         Celsius          -252.15
;         Fahrenheit       -421.87
;         Rankine            37.80
; ESC = End.
; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 16
; Folding = -
; EnableXP
; EnableUnicode