﻿;==================================================================
; Rosetta Task: Time a function
;
; Write a program which uses a timer (with the least granularity available on your system) to time how 
; long a function takes to execute.
; 
; Whenever possible, use methods which measure only the processing time used by the current 
; process; instead of the difference in system time between start and finish, which could include 
; time used by other processes on the computer.
; 
; This task is intended as a subtask for measure relative performance of sorting algorithms implementations.
;==================================================================

;==================================================================
;------- Hi-res version Library: Droopy - uses a hi-res timer
;==================================================================

;           If OpenConsole()
;             Define Timed.f, cnt
;             PrintN("Starting timing of a calculation,")
;             PrintN("for this we test how many of 0-1000000 are palindromic.")
;             ; Dependent on Droopy-library
;             If MeasureHiResIntervalStart()
;               ; Same Foo() as above...
;               cnt=Foo(1000000)
;               Timed=MeasureHiResIntervalStop()
;             EndIf
;             PrintN("The function need "+StrF(Timed*1000,3)+" msec,")
;             PrintN("and "+Str(cnt)+" are palindromic.")
;             Print("Press ENTER to exit."): Input()
;           EndIf

; Starting timing of a calculation,
; For this we test how many of 0-1000000 are palindromic.
; The function need 604.341 msec,
; And 1999 are palindromic.
; Press ENTER To exit.

;==================================================================
;------- Windows API version but does NOT make use of any additional libraries.
;==================================================================
Procedure Foo(Limit)
  Protected i, palindromic, String$
  For i=0 To Limit
    String$=Str(i)
    If String$=ReverseString(String$)
      palindromic+1
    EndIf
  Next
  ProcedureReturn palindromic
EndProcedure

Procedure.f ticksHQ(reportIfPresent = #False)
  Static maxfreq.q 
  Protected T.q 
  If reportIfPresent Or maxfreq = 0 
    QueryPerformanceFrequency_(@maxfreq) 
    If maxfreq
      ProcedureReturn 1.0
    Else
      ProcedureReturn 0
    EndIf 
  EndIf 
  QueryPerformanceCounter_(@T) 
  ProcedureReturn T / maxfreq ;Result is in milliseconds
EndProcedure 
 
If OpenConsole()
  Define timed.f, cnt
  PrintN("Starting timing of a calculation,")
  PrintN("for this we test how many of 0-1000000 are palindromic.")
  ; Dependent on Windows API
  If ticksHQ(#True)
    timed = ticksHQ() ;start time
    ; Same Foo() as above...
    cnt = Foo(1000000)
    timed = ticksHQ() - timed ;difference
  EndIf
  PrintN("The function need " + StrF(timed * 1000, 3) + " msec,")
  PrintN("and " + Str(cnt) + " are palindromic.")
  Print("Press ENTER to exit."): Input()
EndIf
; Sample output:
; 
; Starting timing of a calculation,
; For this we test how many of 0-1000000 are palindromic.
; The function need 174.811 msec,
; And 1999 are palindromic.


; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 10
; Folding = -
; EnableXP
; EnableUnicode