﻿;==================================================================
; Rosetta Task: Time a function
;
; Write a program which uses a timer (with the least granularity available on your system) to time how 
; long a function takes to execute.
; 
; Whenever possible, use methods which measure only the processing time used by the current 
; process; instead of the difference in system time between start and finish, which could include 
; time used by other processes on the computer.
; 
; This task is intended as a subtask for measure relative performance of sorting algorithms implementations.
;==================================================================

; This version uses the built in timer, on Windows it has an accuracy of ~10-15 msec.

Procedure Foo(Limit)
  Protected i, palindromic, String$
  For i=0 To Limit
    String$=Str(i)
    If String$=ReverseString(String$)
      palindromic+1
    EndIf
  Next
  ProcedureReturn palindromic
EndProcedure
 
If OpenConsole()
  Define Start, Stop, cnt
  PrintN("Starting timing of a calculation,")
  PrintN("for this we test how many of 0-1000000 are palindromic.")
  Start=ElapsedMilliseconds()
  cnt=Foo(1000000)
  Stop=ElapsedMilliseconds()
  PrintN("The function need "+Str(stop-Start)+" msec,")
  PrintN("and "+Str(cnt)+" are palindromic.")
  Print("Press ENTER to exit."): Input()
EndIf

; Starting timing of a calculation,
; For this we test how many of 0-1000000 are palindromic.
; The function need 577 msec,
; And 1999 are palindromic.
; Press ENTER To exit.

; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 10
; Folding = -
; EnableXP
; EnableUnicode