﻿;==================================================================
; Rosetta Task: Towers of Hanoi
;
; In this task, the goal is to solve the Towers of Hanoi problem with recursion.
;==================================================================

; Algorithm according To http://en.wikipedia.org/wiki/Towers_of_Hanoi

;           Procedure Hanoi(n, A.s, C.s, B.s)
;             If n
;               Hanoi(n-1, A, B, C)
;               PrintN("Move the plate from "+A+" to "+C)
;               Hanoi(n-1, B, C, A)
;             EndIf
;           EndProcedure

; Full program....

Procedure Hanoi(n, A.s, C.s, B.s)
  If n
    Hanoi(n-1, A, B, C)
    PrintN("Move the plate from "+A+" to "+C)
    Hanoi(n-1, B, C, A)
  EndIf
EndProcedure
 
If OpenConsole()
  Define n=3
  PrintN("Moving "+Str(n)+" pegs."+#CRLF$)
  Hanoi(n,"Left Peg","Middle Peg","Right Peg")
  PrintN(#CRLF$+"Press ENTER to exit."): Input()
EndIf
; Output:
; Moving 3 pegs.
; 
; Move the plate from Left Peg To Middle Peg
; Move the plate from Left Peg To Right Peg
; Move the plate from Middle Peg To Right Peg
; Move the plate from Left Peg To Middle Peg
; Move the plate from Right Peg To Left Peg
; Move the plate from Right Peg To Middle Peg
; Move the plate from Left Peg To Middle Peg
; 
; Press ENTER To exit.
; IDE Options = PureBasic 5.42 Beta 1 LTS (Windows - x86)
; CursorPosition = 16
; Folding = -
; EnableUnicode
; EnableXP