﻿;==================================================================
; Rosetta Task: Undefined values
;
; For languages which have an explicit notion of an undefined value, identify and exercise those language's 
; mechanisms for identifying and manipulating a variable's value's status as being undefined
;==================================================================

; Variables are defined through a formal declaration or simply upon first use. Each variable is initialized 
; to a value. PureBasic does not allow changing of a variable's status at runtime. It can be tested at 
; compile-time and acted upon, however, it cannot be undefined once it is defined.

If OpenConsole()
 
  CompilerIf Defined(var, #PB_Variable)
    PrintN("var is defined at first check")
  CompilerElse
    PrintN("var is undefined at first check")
    Define var
  CompilerEndIf
 
  CompilerIf Defined(var, #PB_Variable)
    PrintN("var is defined at second check")
  CompilerElse
    PrintN("var is undefined at second check")
    Define var
  CompilerEndIf
 
  Print(#CRLF$ + #CRLF$ + "Press ENTER to exit")
  Input()
  CloseConsole()
 
EndIf
; Sample output:
; 
; var is undefined at first check
; var is defined at second check
; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 7
; EnableXP
; EnableUnicode