﻿;==================================================================
; Rosetta Task: Walk a directory - Non-recursively
;
; Walk a given directory and print the names of files matching a given pattern. (How is "pattern" defined? 
; substring match? DOS pattern? BASH pattern? ZSH pattern? Perl regular expression?)

; Note: This task is for non-recursive methods. These tasks should read a single directory, not an entire directory tree
;==================================================================

; The match is made using DOS wildcards. It could easily be modified to match based on a regular expression
;  if desired (i.e. using the PCRE library).

Procedure walkDirectory(directory.s = "", pattern.s = "")
  Protected directoryID
 
  directoryID = ExamineDirectory(#PB_Any,directory,pattern)
  If directoryID
    While NextDirectoryEntry(directoryID)
      PrintN(DirectoryEntryName(directoryID))
    Wend
    FinishDirectory(directoryID)
  EndIf 
EndProcedure
 
If OpenConsole()
  walkDirectory()  
 
  Print(#CRLF$ + #CRLF$ + "Press ENTER to exit")
  Input()
  CloseConsole()
EndIf
; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 10
; Folding = -
; EnableXP
; EnableUnicode