﻿;==================================================================
; Rosetta Task: Walk a directory - Recursively
;
; Walk a given directory tree and print files matching a given pattern.

; Note: This task is for recursive methods. These tasks should read an entire directory tree, NOT a single
; directory. 
;
; For code a code example that reads a single directory... see: "Walk a directory - Non-recursively.pb"
;==================================================================

Procedure.s WalkRecursive(dir,path.s,Pattern.s="\.txt$")
  Static RegularExpression 
  If Not RegularExpression
    RegularExpression=CreateRegularExpression(#PB_Any,Pattern)
  EndIf
 
  While NextDirectoryEntry(dir)
    If DirectoryEntryType(dir)=#PB_DirectoryEntry_Directory
      If DirectoryEntryName(dir)<>"." And DirectoryEntryName(dir)<>".."
        If ExamineDirectory(dir+1,path+DirectoryEntryName(dir),"")
          WalkRecursive(dir+1,path+DirectoryEntryName(dir)+"\",Pattern)
          FinishDirectory(dir+1)
        Else
          Debug "Error in "+path+DirectoryEntryName(dir)
        EndIf
      EndIf
    Else ; e.g. #PB_DirectoryEntry_File 
      If MatchRegularExpression(RegularExpression,DirectoryEntryName(dir))
        Debug DirectoryEntryName(dir)
      EndIf
    EndIf
  Wend
EndProcedure

;==================================================================
;------- Implementation; Find all .log-files in the C:\Windows tree
;==================================================================

ExamineDirectory(1,"C:\WINDOWS\","")
WalkRecursive(1,"C:\WINDOWS\","\.log$")
FinishDirectory(1)
; IDE Options = PureBasic 5.42 Beta 1 LTS (Windows - x86)
; CursorPosition = 8
; FirstLine = 5
; Folding = -
; EnableUnicode
; EnableXP