﻿;==================================================================
; Rosetta Task: Write float arrays to a text file
;
; Write two equal-sized numerical arrays 'x' and 'y' to a two-column text file named 'filename'.
; 
; The first column of the file contains values from an 'x'-Array with a given 'xprecision', the second -- values
;  from 'y'-Array With 'yprecision'.
; 
; For example, considering: 
;    x = {1, 2, 3, 1e11};
;    y = {1, 1.4142135623730951, 1.7320508075688772, 316227.76601683791}; 
;                                                           /* sqrt(x) */
;    xprecision = 3;
;    yprecision = 5;
;
; The file is: 
;    1    1
;    2    1.4142
;    3    1.7321
;    1e+011   3.1623e+005
;
; This task is intended qs a subtask for measure relative performance of sorting algorithms implementations.
;==================================================================

#Size = 4
 
DataSection
  Data.f 1, 2, 3, 1e11 ;x values, how many values needed is determined by #Size
EndDataSection
 
Dim x.f(#Size - 1)
Dim y.f(#Size - 1)
 
Define i
For i = 0 To #Size - 1
  Read.f x(i)
  y(i) = Sqr(x(i))
Next
 
Define file$, fileID, xprecision = 3, yprecision = 5, output$
 
file$ = SaveFileRequester("Text file for float data", "xydata.txt","Text file | *.txt", 0)
If file$
  fileID = OpenFile(#PB_Any, file$)
  If fileID
    For i = 0 To #Size - 1
      output$ = StrF(x(i), xprecision) + Chr(9) + StrF(y(i), yprecision)
      WriteStringN(fileID, output$)
    Next 
    CloseFile(fileID)
  EndIf
EndIf
; Output:
; To text file:
; 1.000	1.00000
; 2.000	1.41421
; 3.000	1.73205
; 99999997952.000	316227.75000
; IDE Options = PureBasic 5.50 beta 3 (Windows - x64)
; CursorPosition = 20
; EnableXP
; EnableUnicode